#include "stdafx.h"


void Init3DSForSave(database3ds** Db3ds)
{
    ClearErrList3ds();

    InitDatabase3ds(Db3ds);
    PRINT_ERRORS_EXIT(stderr);

    CreateNewDatabase3ds(*Db3ds, MeshFile);
    PRINT_ERRORS_EXIT(stderr);

    meshset3ds*     lpMesh  = NULL;
    background3ds*  lpBgnd  = NULL;   
    atmosphere3ds*  lpAtmo  = NULL;

    /*--- MESH SETTINGS */
    InitMeshSet3ds(&lpMesh);
    ON_ERROR_RETURN;

    lpMesh->ambientlight.r = lpMesh->ambientlight.g = lpMesh->ambientlight.b = 0.15F;

    PutMeshSet3ds(*Db3ds, lpMesh);  
    ON_ERROR_RETURN;

    ReleaseMeshSet3ds(&lpMesh);
    ON_ERROR_RETURN;

    /*--- BACKGROUND */
    InitBackground3ds(&lpBgnd);
    ON_ERROR_RETURN;

    /*--- Set-up Gradient */
    lpBgnd->vgradient.top.r = 0.5F;
    lpBgnd->vgradient.top.g = 0.0F;
    lpBgnd->vgradient.top.b = 0.0F;

    lpBgnd->vgradient.mid.r = 1.0F;
    lpBgnd->vgradient.mid.g = 0.0F;
    lpBgnd->vgradient.mid.b = 0.5F;

    lpBgnd->vgradient.bottom.r = 0.0F;
    lpBgnd->vgradient.bottom.g = 0.0F;
    lpBgnd->vgradient.bottom.b = 0.0F;
    lpBgnd->vgradient.gradpercent = 0.5F;

    lpBgnd->bgndused = UseVGradientBgnd;

    PutBackground3ds(*Db3ds, lpBgnd);
    ON_ERROR_RETURN;

    ReleaseBackground3ds(&lpBgnd);
    ON_ERROR_RETURN;

    /*--- ATMOSPHERE */
    InitAtmosphere3ds(&lpAtmo);
    ON_ERROR_RETURN;

    lpAtmo->fog.nearplane = 0.0F;
    lpAtmo->fog.neardensity = 0.0F;
    lpAtmo->fog.farplane = 100.0F;
    lpAtmo->fog.fardensity = 100.0F;
    lpAtmo->fog.fogcolor.r = 0.8F;
    lpAtmo->fog.fogcolor.g = 0.0F;
    lpAtmo->fog.fogcolor.b = 0.0F;
    lpAtmo->fog.fogbgnd = True3ds;
    lpAtmo->activeatmo = NoAtmo; //UseFog;

    PutAtmosphere3ds(*Db3ds, lpAtmo);
    ON_ERROR_RETURN;

    ReleaseAtmosphere3ds(&lpAtmo);
    ON_ERROR_RETURN;
}


//
void Save3DS(database3ds** Db3ds,char* lpszFileName3ds)
{
    file3ds*        lpFile3ds;

    lpFile3ds = OpenFile3ds(lpszFileName3ds, "w");
    PRINT_ERRORS_EXIT(stderr);

    WriteDatabase3ds(lpFile3ds, *Db3ds);
    PRINT_ERRORS_EXIT(stderr);

    CloseAllFiles3ds();
    PRINT_ERRORS_EXIT(stderr);

    ReleaseDatabase3ds(Db3ds);
    PRINT_ERRORS_EXIT(stderr);
}


