#pragma once


#define SetPoint(p, a, b, c) (p).x = a; (p).y = b; (p).z = c;
#define SetFace(f, a, b, c, d) (f).v1 = a; (f).v2 = b; (f).v3 = c; (f).flag = d;
#define SetColor(c,rf,gf,bf) (c).r = rf; (c).g = gf; (c).b = bf;

#define ON_ERROR_STOP {if(ftkerr3ds && !ignoreftkerr3ds) DebugBreak();}

#define ON_ERROR_PRINT {if(ftkerr3ds && !ignoreftkerr3ds) { CString s; s.Format("Erreur 3DS:%ld\n",(long)ftkerr3ds); AfxMessageBox(s,MB_OK | MB_ICONSTOP); } }

#define PUT_LIGHT(fx,fy,fz,its,namel)     \
    InitLight3ds(&lpSlite);               \
    ON_ERROR_RETURNR(false);              \
                                          \
    strcpy(lpSlite->name, namel);         \
    lpSlite->pos.x = fx;                  \
    lpSlite->pos.y = fy;                  \
    lpSlite->pos.z = fz;                  \
    lpSlite->color.r = its;               \
    lpSlite->color.g = its;               \
    lpSlite->color.b = its;               \
    lpSlite->dloff = False3ds;            \
    lpSlite->attenuation.on = False3ds;   \
    lpSlite->attenuation.inner = 10.0F;   \
    lpSlite->attenuation.outer = 100.0F;  \
                                          \
    PutOmnilight3ds(Db3ds, lpSlite);      \
    ON_ERROR_RETURNR(false);              \
                                          \
    ReleaseLight3ds(&lpSlite);            \
    ON_ERROR_RETURNR(false);              \

#define PutMaterial(FaceIndex,r,g,b)                               \
        material3ds* lpMat = NULL;                                 \
        InitMaterial3ds(&lpMat);                                   \
        ON_ERROR_RETURNR(false)                                    \
                                                                   \
        sprintf(lpMat->name,"Mat%.4d",dwNumMat++);                 \
        SetColor(lpMat->diffuse,r,g,b);                            \
        lpMat->shading = Phong;                                    \
                                                                   \
        strcpy(lpObj->matarray[dwNumMat-1].name,lpMat->name);      \
        lpObj->matarray[dwNumMat-1].nfaces = 1;                    \
        lpObj->matarray[dwNumMat-1].faceindex = new ushort3ds[1];  \
        lpObj->matarray[dwNumMat-1].faceindex[0] = FaceIndex;      \
                                                                   \
        PutMaterial3ds(Db3ds, lpMat);                              \
        ON_ERROR_RETURNR(false)                                    \
        ReleaseMaterial3ds(&lpMat);                                \
        ON_ERROR_RETURNR(false)                                    \

#define PutMaterial2(FaceIndex,r,g,b)                              \
        material3ds* lpMat = NULL;                                 \
        InitMaterial3ds(&lpMat);                                   \
        ON_ERROR_RETURNR(false)                                    \
                                                                   \
        sprintf(lpMat->name,"Mat%.4d",dwNumMat++);                 \
        SetColor(lpMat->diffuse,r,g,b);                            \
        lpMat->shading = Phong;                                    \
                                                                   \
        strcpy(lpObj->matarray[dwNumMat-1].name,lpMat->name);      \
        lpObj->matarray[dwNumMat-1].nfaces = 2;                    \
        lpObj->matarray[dwNumMat-1].faceindex = new ushort3ds[2];  \
        lpObj->matarray[dwNumMat-1].faceindex[0] = FaceIndex;      \
        lpObj->matarray[dwNumMat-1].faceindex[1] = FaceIndex+1;    \
                                                                   \
        PutMaterial3ds(Db3ds, lpMat);                              \
        ON_ERROR_RETURNR(false)                                    \
        ReleaseMaterial3ds(&lpMat);                                \
        ON_ERROR_RETURNR(false)                                    \

#define CREATE_MATERIAL(dwNumMat)                                    \
        material3ds* lpMat = NULL;                                   \
        InitMaterial3ds(&lpMat);                                     \
        ON_ERROR_RETURNR(false)                                      \
                                                                     \
        sprintf(lpMat->name,"tile%ld",dwNumMat);                     \
        SetColor(lpMat->diffuse,0.999f,0.999f,0.999f);               \
        lpMat->shading = Phong;                                      \
        InitBitmap3ds(&lpMat->texture.map);                          \
        ON_ERROR_RETURNR(false)                                      \
        sprintf(lpMat->texture.map.name,"TRText%.2d.tga",dwNumMat);  \
        lpMat->texture.map.percent=1.0f;                             \
                                                                     \
        PutMaterial3ds(Db3ds, lpMat);                                \
        ON_ERROR_RETURNR(false)                                      \
        ReleaseMaterial3ds(&lpMat);                                  \
        ON_ERROR_RETURNR(false)                                      \


#define CREATE_MATERIAL_FOR_TILE()                                   \
        material3ds* lpMat = NULL;                                   \
        InitMaterial3ds(&lpMat);                                     \
        ON_ERROR_RETURNR(false)                                      \
                                                                     \
        strcpy(lpMat->name,"tile0");                                 \
        SetColor(lpMat->diffuse,0.999f,0.999f,0.999f);               \
        lpMat->shading = Phong;                                      \
        InitBitmap3ds(&lpMat->texture.map);                          \
        ON_ERROR_RETURNR(false)                                      \
        sprintf(lpMat->texture.map.name,"%s.tga",lpszTextureName);   \
        lpMat->texture.map.percent=1.0f;                             \
                                                                     \
        PutMaterial3ds(Db3ds, lpMat);                                \
        ON_ERROR_RETURNR(false)                                      \
        ReleaseMaterial3ds(&lpMat);                                  \
        ON_ERROR_RETURNR(false)                                      \


#define CREATE_MATERIAL_COLOR(dwNumMat,r,g,b)                        \
        material3ds* lpMat = NULL;                                   \
        InitMaterial3ds(&lpMat);                                     \
        ON_ERROR_RETURNR(false)                                      \
                                                                     \
        sprintf(lpMat->name,"color%ld",dwNumMat);                    \
        SetColor(lpMat->diffuse,r,g,b);                              \
        lpMat->shading = Phong;                                      \
                                                                     \
        PutMaterial3ds(Db3ds, lpMat);                                \
        ON_ERROR_RETURNR(false)                                      \
        ReleaseMaterial3ds(&lpMat);                                  \
        ON_ERROR_RETURNR(false)                                      \


#define INIT_OBJ(numvert,numtri)                                      \
        { mesh3ds*    lpObj           = NULL;                         \
        InitMeshObj3ds(&lpObj, numvert, numtri, InitNoExtras3ds);     \
        ON_ERROR_RETURNR(false)                                       \
        wsprintf(lpObj->name,"%s%ld",lpszObjName,(DWORD)wFaceIndex);  \


#define INIT_OBJ_TEXT(numvert,numtri,tile)                              \
        { mesh3ds*    lpObj           = NULL;                           \
        InitMeshObj3ds(&lpObj, numvert, numtri, InitTextArray3ds);      \
        ON_ERROR_RETURNR(false)                                         \
        wsprintf(lpObj->name,"%s%ld",lpszObjName,(DWORD)wFaceIndex);    \
        lpObj->nmats = 1;                                               \
        lpObj->matarray = new objmat3ds;                                \
        wsprintf(lpObj->matarray->name,"tile%ld",(long)tile);           \
        lpObj->matarray->nfaces=numtri;                                 \
        lpObj->matarray->faceindex = new ushort3ds[numtri];             \
        for(short j=0; j<numtri; j++) lpObj->matarray->faceindex[j]=j;  \


#define END_OBJ()                  \
        FillMatrix3ds(lpObj);      \
        PutMesh3ds(Db3ds, lpObj);  \
        ON_ERROR_RETURNR(false)    \
        RelMeshObj3ds(&lpObj);     \
        ON_ERROR_RETURNR(false) }  \


#define SETVERTEX_OBJ(numvertsrc,numvertdest)                       \
        {                                                           \
        TR2_VERTEX*  lpVertex = &lpMesh->lpVertices[numvertsrc];    \
                                                                    \
        float       fX =  (float)(lpVertex->sX + fTransX);          \
        float       fY =  (float)(lpVertex->sZ + fTransZ);          \
        float       fZ = -(float)(lpVertex->sY + fTransY);          \
                                                                    \
        if(fX < fMinX) fMinX = fX; else if(fX > fMaxX) fMaxX = fX;  \
        if(fY < fMinY) fMinY = fY; else if(fY > fMaxY) fMaxY = fY;  \
        if(fZ < fMinZ) fMinZ = fZ; else if(fZ > fMaxZ) fMaxZ = fZ;  \
                                                                    \
        SetPoint(lpObj->vertexarray[numvertdest], fX, fY, fZ);      \
        }                                                           \


#define SETVERTEX_OBJ_TEXT(numvertsrc,numvertdest,fu,fv)            \
        {                                                           \
        TR2_VERTEX*  lpVertex = &lpMesh->lpVertices[numvertsrc];    \
                                                                    \
        float       fX =  (float)(lpVertex->sX + fTransX);          \
        float       fY =  (float)(lpVertex->sZ + fTransZ);          \
        float       fZ = -(float)(lpVertex->sY + fTransY);          \
                                                                    \
        if(fX < fMinX) fMinX = fX; else if(fX > fMaxX) fMaxX = fX;  \
        if(fY < fMinY) fMinY = fY; else if(fY > fMaxY) fMaxY = fY;  \
        if(fZ < fMinZ) fMinZ = fZ; else if(fZ > fMaxZ) fMaxZ = fZ;  \
                                                                    \
        SetPoint(lpObj->vertexarray[numvertdest], fX, fY, fZ);      \
        lpObj->textarray[numvertdest].u = fu;                       \
        lpObj->textarray[numvertdest].v = 1.0f - fv;                \
        }                                                           \


#define COMPUTE_UV(notxt)                                                        \
    fU = lpVertTexture[notxt].bXPixel; fU += lpVertTexture[notxt].cXCoordinate;  \
    fV = lpVertTexture[notxt].bYPixel; fV += lpVertTexture[notxt].cYCoordinate;  \


void Init3DSForSave(database3ds** Db3ds);
void Save3DS(database3ds** Db3ds,char* lpszFileName3ds);
