#pragma once


//
// This class represents the positionning (translation / rotation) 
// of each mesh for an animation's key
//
class CAnimData
{
public:

    // Constructors / destructors
    CAnimData() : m_Quat(0), m_vecTrans(0), m_wTRAngle1(0), m_wTRAngle2(0) { }
    CAnimData(const CAnimData& AnimData) :
        m_Quat(AnimData.m_Quat), m_vecTrans(AnimData.m_vecTrans), m_wTRAngle1(AnimData.m_wTRAngle1), m_wTRAngle2(AnimData.m_wTRAngle2)
                                                        { }
    CAnimData(CQuaternion& Quat, CVect3D vecTrans, WORD wTRAngle1, WORD wTRAngle2) :
        m_Quat(Quat), m_vecTrans(vecTrans), m_wTRAngle1(wTRAngle1), m_wTRAngle2(wTRAngle2) { }
    CAnimData(FLOAT fAngleX, FLOAT fAngleY, FLOAT fAngleZ, CVect3D vecTrans, WORD wTRAngle1, WORD wTRAngle2);

    // Accessors
    const CQuaternion&  quatGetQuaternion() const       { return m_Quat; }
    const CVect3D&      vecGetTrans()       const       { return m_vecTrans; }
    void                vGetTRAngle(WORD& wTRAngle1, WORD& wTRAngle2) const  { wTRAngle1 = m_wTRAngle1; wTRAngle2 = m_wTRAngle2; }

    // Processors
    static void vInterpolate(const CAnimData& Data1, const CAnimData& Data2, CAnimData* lpDataRes, FLOAT fInterpFactor);

private:

    // Data members
    CQuaternion         m_Quat;                     // rotation of the mesh
    CVect3D             m_vecTrans;                 // translation of the mesh
    WORD                m_wTRAngle1;
    WORD                m_wTRAngle2;
};
