#pragma once


//
// This class handles an animation's key. A key is made of a CAnimData list,
// each CAnimData representing the positionning of one mesh of the hierarchy
//
class CAnimKey
{
public:

    // Constructors / destructors
    CAnimKey()                                          { }
    CAnimKey(DWORD dwTime, DWORD dwNumData, CBoundingBox BBKey) :
        m_dwTime(dwTime), m_dwNumData(dwNumData), m_BBKey(BBKey)
                                                        { }

    virtual ~CAnimKey()                                 { m_ListData.clear(); }

    // Accessors
    const   CAnimData& GetData(DWORD dwNumData) const   { return m_ListData[dwNumData]; }
    const   CBoundingBox& GetBB()               const   { return m_BBKey; }

    DWORD   dwGetTime()                         const   { return m_dwTime; }
    DWORD   dwGetNumData()                      const   { return m_dwNumData; }

    // Processors
    void    vPushData(CAnimData& Data)                  { m_ListData.push_back(Data); }
    void    vPackData()                                 { m_ListData.resize(m_ListData.size()); }

private:

    typedef std::vector<CAnimData> AnimListData;

    // Data members
    DWORD               m_dwTime;                       // time of the key
    DWORD               m_dwNumData;                    // num data (ie. meshes) making the key
    CBoundingBox        m_BBKey;                        // bounding box of the key
    AnimListData        m_ListData;                     // list of data
};
