#if !defined(AFX_EDITMESH_H__D75C4CE1_F1E2_11D3_AA63_00105A49000B__INCLUDED_)
#define AFX_EDITMESH_H__D75C4CE1_F1E2_11D3_AA63_00105A49000B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EditMesh.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEditMesh form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "OpenGLWnd1.h"

class CHandleMesh;
class CToolboxMesh;

class CEditMesh : public CFormView
{
protected:
	CEditMesh();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CEditMesh)

// Form Data
public:
	//{{AFX_DATA(CEditMesh)
	enum { IDD = IDD_EDIT_MESH };
	//}}AFX_DATA

// Attributes
public:

// Operations
public:

    void    vSetDataTypeHandler(CHandleMesh* lpHandler);
    void    vReloadTextures();
    BOOL    boOnIdle();

    void    vRedrawOpenGLWnd() { if(m_OpenGLWnd) m_OpenGLWnd->InvalidateRect(NULL,FALSE); }
    void    vSetAutomaticCamera(bool boAutomaticCamera) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetAutomaticCamera(boAutomaticCamera); }
    void    vSetShowAxis(bool boShow) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetShowAxis(boShow); }
    void    vSetBkgColor(COLORREF BkgColor) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetBkgColor(BkgColor); }
    void    vSetShowCollSphere(bool boCollSphereShow) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetShowCollSphere(boCollSphereShow); }
    void    vSetShowVertices(bool boShowVertices) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetShowVertices(boShowVertices); }
    void    vSetShowStaticBB1(bool boOk) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetShowStaticBB1(boOk); }
    void    vSetStaticBB1IsSel(bool boOk) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetStaticBB1IsSel(boOk); }
    void    vSetShowStaticBB2(bool boOk) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetShowStaticBB2(boOk); }
    void    vSetStaticBB2IsSel(bool boOk) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetStaticBB2IsSel(boOk); }

    void    vRelease();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditMesh)
	public:
	virtual void OnInitialUpdate();
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CEditMesh();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CEditMesh)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

    void    vCreateOpenGLWnd();
    void    vCheckKeys(float fFrameRate);

    CHandleMesh*        m_lpDataHandler;
    COpenGLWnd*         m_OpenGLWnd;
    bool                m_OpenGLWndCreated;
    CToolboxMesh*       m_lpToolbox;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITMESH_H__D75C4CE1_F1E2_11D3_AA63_00105A49000B__INCLUDED_)
