// EditMoveable.cpp : implementation file
//

#include "stdafx.h"
#include "TRViewer.h"
#include "MainFrm.h"
#include "EditMoveable.h"
#include "HandleMoveable.h"
#include "ToolboxMoveable.h"


#ifdef _DEBUG
//!#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define OPENGLWND_LEFT_OFFSET       8
#define OPENGLWND_TOP_OFFSET        4
#define OPENGLWND_RIGHT_OFFSET      4
#define OPENGLWND_BOTTOM_OFFSET     4

/////////////////////////////////////////////////////////////////////////////
// CEditMoveable

IMPLEMENT_DYNCREATE(CEditMoveable, CFormView)

CEditMoveable::CEditMoveable()
	: CFormView(CEditMoveable::IDD)
{
	//{{AFX_DATA_INIT(CEditMoveable)
	//}}AFX_DATA_INIT
    m_lpDataHandler     = NULL;
    m_OpenGLWnd         = NULL;
    m_OpenGLWndCreated  = false;
    m_lpToolbox         = reinterpret_cast<CToolboxMoveable*> (((CMainFrame*)(AfxGetApp()->m_pMainWnd))->lpGetToolbox(TOOLBOX_MOVEABLE));
}

CEditMoveable::~CEditMoveable()
{
    vRelease();
}

void CEditMoveable::vRelease()
{
    m_lpToolbox->vSetDataTypeHandler(NULL,NULL);

    if(m_OpenGLWndCreated)
        {
        m_OpenGLWnd->DestroyWindow();
        delete m_OpenGLWnd;
        }

    m_OpenGLWnd = NULL;
    m_OpenGLWndCreated = false;
    m_lpDataHandler = NULL;
}


void CEditMoveable::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditMoveable)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditMoveable, CFormView)
	//{{AFX_MSG_MAP(CEditMoveable)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEWHEEL()
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditMoveable diagnostics

#ifdef _DEBUG
void CEditMoveable::AssertValid() const
{
	CFormView::AssertValid();
}

void CEditMoveable::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditMoveable message handlers

void CEditMoveable::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

    SetScrollSizes(MM_TEXT,CSize(0,0));
}


void CEditMoveable::vSetDataTypeHandler(CHandleMoveable* lpHandler,bool boForceNewMoveable /*= false*/)
{
    m_lpDataHandler = lpHandler;

    if(lpHandler  &&  !m_OpenGLWndCreated) vCreateOpenGLWnd();

    if(m_OpenGLWndCreated)
        {
        m_OpenGLWnd->vSetGfxAddr(m_lpDataHandler->GetMoveable(),TrObj_Type_Moveable,false,-1);
        }

    m_lpToolbox->vSetDataTypeHandler(lpHandler,this,boForceNewMoveable);

    InvalidateRect(NULL);
}


void CEditMoveable::OnDraw(CDC* pDC) 
{
}


void CEditMoveable::vCreateOpenGLWnd()
{
    RECT rect;

    GetClientRect(&rect);

    rect.left   = OPENGLWND_LEFT_OFFSET;
    rect.top    = OPENGLWND_TOP_OFFSET;
    rect.bottom -= OPENGLWND_BOTTOM_OFFSET;
    rect.right  -= OPENGLWND_RIGHT_OFFSET;

    m_OpenGLWnd = new COpenGLWnd;
 
    m_OpenGLWnd->Create("static","",WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,rect,this,12301);
    m_OpenGLWnd->ShowWindow(SW_SHOW);
 
    m_OpenGLWndCreated = true;
}


void CEditMoveable::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
    	
    if(m_OpenGLWndCreated)
        {
        m_OpenGLWnd->SetWindowPos(NULL,OPENGLWND_LEFT_OFFSET,OPENGLWND_TOP_OFFSET,cx-OPENGLWND_LEFT_OFFSET-OPENGLWND_RIGHT_OFFSET,cy-OPENGLWND_BOTTOM_OFFSET-OPENGLWND_TOP_OFFSET,0);
        }
}


BOOL CEditMoveable::boOnIdle()
{
    if(m_OpenGLWndCreated)
        {
        CMainFrame* lpMainFrame = (CMainFrame*)(AfxGetApp()->m_pMainWnd);

        if(lpMainFrame->boIsManualCamera())
            {
            m_OpenGLWnd->vCheckKeys();
            vCheckKeys(m_OpenGLWnd->fGetFrameRate());
            }
        vRedrawOpenGLWnd();
        }

    return TRUE;
}


void CEditMoveable::vCheckKeys(float fFrameRate)
{
    bool boShifted  = GetAsyncKeyState(VK_SHIFT)   & 0x8001 ? true : false;
    bool boCtrled   = GetAsyncKeyState(VK_CONTROL) & 0x8001 ? true : false;

    if(fFrameRate == 0.0f) fFrameRate = 1.0f;

    bit16 sStep = 70.0f / fFrameRate; if(!sStep) sStep = 1;

    CTrMvb*   lpMoveable  = m_lpDataHandler->GetMoveable();

    if(!lpMoveable  ||  m_dwNumSelectedMesh == -1  ||  (!boShifted  &&  !boCtrled)) return;

    bit16 sXSgn = GetAsyncKeyState(VK_LEFT)  & 0x8001 ? -1 : GetAsyncKeyState(VK_RIGHT) & 0x8001 ? +1 : 0;
    bit16 sYSgn = GetAsyncKeyState(VK_PRIOR) & 0x8001 ? -1 : GetAsyncKeyState(VK_NEXT)  & 0x8001 ? +1 : 0;
    bit16 sZSgn = GetAsyncKeyState(VK_DOWN)  & 0x8001 ? -1 : GetAsyncKeyState(VK_UP)    & 0x8001 ? +1 : 0;

    if(!sXSgn  &&  !sYSgn  &&  !sZSgn) return;

    /*!DWORD dwNumMesh = m_lpDataHandler->lpGetTRFile()->GetTRFile().tr123File.lpMeshPointers[lpMoveable->wStartingMesh + m_dwNumSelectedMesh];

    if(boShifted)
        {
        m_lpDataHandler->lpGetTRFile()->vTranslateMeshInMoveable(lpMoveable,dwNumMesh,sStep * sXSgn,sStep * sYSgn,sStep * sZSgn,false);
        }

    if(boCtrled)
        {
        m_lpDataHandler->lpGetTRFile()->vTranslateMeshInMoveable(lpMoveable,dwNumMesh,sStep * sXSgn,sStep * sYSgn,sStep * sZSgn,true);
        }

    m_lpToolbox->vRefreshExtents();
    m_lpDataHandler->vSetChanged();*/
}


void CEditMoveable::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
    if(m_OpenGLWndCreated  &&  bActivate) m_OpenGLWnd->vActivateWnd();

    if(bActivate)
        {
        CMainFrame* lpFrame = (CMainFrame*)(AfxGetApp()->m_pMainWnd);

        if(lpFrame->boToolboxIsVisible()) lpFrame->vSetToolboxType(TOOLBOX_MOVEABLE);
        m_lpToolbox->vSetDataTypeHandler(bActivate ? m_lpDataHandler : NULL,bActivate ? this : NULL);
        }

    if(pActivateView  ||  pDeactiveView)
	    CFormView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}


void CEditMoveable::vReloadTextures()
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->vReleaseTextures();
}


void CEditMoveable::OnLButtonDown(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnLButtonDown(nFlags, point);
	
	CFormView::OnLButtonDown(nFlags, point);
}


void CEditMoveable::OnLButtonUp(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnLButtonUp(nFlags, point);
	
	CFormView::OnLButtonUp(nFlags, point);
}


void CEditMoveable::OnMouseMove(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnMouseMove(nFlags, point);
	
	CFormView::OnMouseMove(nFlags, point);
}


void CEditMoveable::OnRButtonDown(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnRButtonDown(nFlags, point);
	
	CFormView::OnRButtonDown(nFlags, point);
}


void CEditMoveable::OnRButtonUp(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnRButtonUp(nFlags, point);
	
	CFormView::OnRButtonUp(nFlags, point);
}


BOOL CEditMoveable::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnMouseWheel(nFlags, zDelta, pt);
	
	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}

void CEditMoveable::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnLButtonDblClk(nFlags, point);
	
	CFormView::OnLButtonDblClk(nFlags, point);
}
