// EditSprite.cpp : implementation file
//

#include "stdafx.h"
#include "trviewer.h"
#include "MainFrm.h"
#include "EditSprite.h"
#include "HandleSprite.h"
#include "ToolboxSprite.h"


#ifdef _DEBUG
//#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define OPENGLWND_LEFT_OFFSET       8
#define OPENGLWND_TOP_OFFSET        4
#define OPENGLWND_RIGHT_OFFSET      4
#define OPENGLWND_BOTTOM_OFFSET     4

/////////////////////////////////////////////////////////////////////////////
// CEditSprite

IMPLEMENT_DYNCREATE(CEditSprite, CFormView)

CEditSprite::CEditSprite()
	: CFormView(CEditSprite::IDD)
{
	//{{AFX_DATA_INIT(CEditSprite)
	//}}AFX_DATA_INIT
    m_lpDataHandler     = NULL;
    m_OpenGLWnd         = NULL;
    m_OpenGLWndCreated  = false;
    m_lpToolbox         = reinterpret_cast<CToolboxSprite*> (((CMainFrame*)(AfxGetApp()->m_pMainWnd))->lpGetToolbox(TOOLBOX_SPRITE));
}

CEditSprite::~CEditSprite()
{
    vRelease();
}

void CEditSprite::vRelease()
{
    m_lpToolbox->vSetDataTypeHandler(NULL,NULL);

    if(m_OpenGLWndCreated)
        {
        m_OpenGLWnd->DestroyWindow();
        delete m_OpenGLWnd;
        }

    m_OpenGLWnd = NULL;
    m_OpenGLWndCreated = false;
    m_lpDataHandler = NULL;
}


void CEditSprite::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditSprite)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditSprite, CFormView)
	//{{AFX_MSG_MAP(CEditSprite)
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEWHEEL()
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditSprite diagnostics

#ifdef _DEBUG
void CEditSprite::AssertValid() const
{
	CFormView::AssertValid();
}

void CEditSprite::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditSprite message handlers

void CEditSprite::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

    SetScrollSizes(MM_TEXT,CSize(0,0));
}


void CEditSprite::vSetDataTypeHandler(CHandleSprite* lpHandler)
{
    m_lpDataHandler = lpHandler;

    if(lpHandler  &&  !m_OpenGLWndCreated) vCreateOpenGLWnd();

    if(m_OpenGLWndCreated)
        {
        m_OpenGLWnd->vSetSprSeqAddr(m_lpDataHandler->GetSpr());
        }

    m_lpToolbox->vSetDataTypeHandler(lpHandler,this);

    InvalidateRect(NULL);
}


void CEditSprite::OnDraw(CDC* pDC) 
{
}


void CEditSprite::vCreateOpenGLWnd()
{
    RECT rect;

    GetClientRect(&rect);

    rect.left   = OPENGLWND_LEFT_OFFSET;
    rect.top    = OPENGLWND_TOP_OFFSET;
    rect.bottom -= OPENGLWND_BOTTOM_OFFSET;
    rect.right  -= OPENGLWND_RIGHT_OFFSET;

    m_OpenGLWnd = new COpenGLWnd;
    m_OpenGLWnd->Create("static","",WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,rect,this,12302);
    m_OpenGLWnd->ShowWindow(SW_SHOW);
    m_OpenGLWnd->vSetSprSeqAddr(m_lpDataHandler->GetSpr());

    m_OpenGLWndCreated = true;
}


void CEditSprite::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
    if(m_OpenGLWndCreated) m_OpenGLWnd->SetWindowPos(NULL,OPENGLWND_LEFT_OFFSET,OPENGLWND_TOP_OFFSET,cx-OPENGLWND_LEFT_OFFSET-OPENGLWND_RIGHT_OFFSET,cy-OPENGLWND_BOTTOM_OFFSET-OPENGLWND_TOP_OFFSET,0);
}


BOOL CEditSprite::boOnIdle()
{
    if(m_OpenGLWndCreated)
        {
        m_OpenGLWnd->vCheckKeys();
        vRedrawOpenGLWnd();
        }

    return TRUE;
}


void CEditSprite::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
    if(m_OpenGLWndCreated  &&  bActivate) m_OpenGLWnd->vActivateWnd();

    if(bActivate)
        {
        CMainFrame* lpFrame = (CMainFrame*)(AfxGetApp()->m_pMainWnd);

        if(lpFrame->boToolboxIsVisible()) lpFrame->vSetToolboxType(TOOLBOX_SPRITE);
        m_lpToolbox->vSetDataTypeHandler(bActivate ? m_lpDataHandler : NULL,bActivate ? this : NULL);
        }

    if(pActivateView  ||  pDeactiveView)
	    CFormView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}


void CEditSprite::vReloadTextures()
{
    if(m_OpenGLWnd) m_OpenGLWnd->vReleaseTextures();
}


void CEditSprite::OnLButtonDown(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnLButtonDown(nFlags, point);
	
	CFormView::OnLButtonDown(nFlags, point);
}


void CEditSprite::OnLButtonUp(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnLButtonUp(nFlags, point);
	
	CFormView::OnLButtonUp(nFlags, point);
}


void CEditSprite::OnMouseMove(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnMouseMove(nFlags, point);
	
	CFormView::OnMouseMove(nFlags, point);
}


void CEditSprite::OnRButtonDown(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnRButtonDown(nFlags, point);
	
	CFormView::OnRButtonDown(nFlags, point);
}


void CEditSprite::OnRButtonUp(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnRButtonUp(nFlags, point);
	
	CFormView::OnRButtonUp(nFlags, point);
}


BOOL CEditSprite::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnMouseWheel(nFlags, zDelta, pt);
	
	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}

void CEditSprite::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
    if(m_OpenGLWndCreated) m_OpenGLWnd->OnLButtonDblClk(nFlags, point);
	
	CFormView::OnLButtonDblClk(nFlags, point);
}
