#if !defined(AFX_FILETREE_H__9FF23391_E165_11D3_AA54_00105A49000B__INCLUDED_)
#define AFX_FILETREE_H__9FF23391_E165_11D3_AA54_00105A49000B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FileTree.h : header file
//

class CChildFrame;
class CHandleBase;
class CTRViewerDoc;
class CHandleMoveables;
class CHandleStaticMeshes;
class CHandleSprites;

#define INSERT(tree,hres,itemParent,classHandle)                                                                         \
    hres = tree->InsertItem(TVIF_TEXT | TVIF_PARAM,(TCHAR*)(LPCTSTR)s,-1,-1,0,0,(long) classHandle,itemParent,TVI_LAST);  \

/////////////////////////////////////////////////////////////////////////////
// CFileTree window
#include "TreeDropTarget.h"

class CFileTree : public CTreeCtrl
{
// Construction
public:
	CFileTree(CChildFrame* lpFrame,CTRFile* lpTRFile,CTRViewerDoc* lpDocument = NULL);

// Attributes
public:

    CTRFile*    lpGetTRFile() { return m_lpTRFile; }

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFileTree)
	protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFileTree();
    void    vInitialize();
    bool    boSave(LPCTSTR lpszFileName);
    void    vRelease();
    void    vSetChanged();
    void    vReleaseNode(HTREEITEM hItem,bool boDeleteItems = false,bool boDontDeleteFirstItem = false);

    CHandleMoveables*       m_lpHandleMoveables;
    CHandleStaticMeshes*    m_lpHandleStaticMeshes;
    CHandleSprites*         m_lpHandleSprites;
    bool                    m_boDeleting;

	// Generated message map functions
protected:
	//{{AFX_MSG(CFileTree)
	afx_msg void OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

private:

    void    ShowPopupMenu(CPoint& point, HTREEITEM hItem);

    HTREEITEM       m_hRootItem;
    CHandleBase*    m_lpSelectedNode;
    CHandleBase*    m_lpOldSelectedNode;
    CChildFrame*    m_lpFrame;
    CTRFile*        m_lpTRFile;
    HTREEITEM       m_pOldSel;
    CHandleBase*    m_lpHandlerPopup;
    CTRViewerDoc*   m_lpDocument;

	CTreeDropTarget m_CTreeDropTarget;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILETREE_H__9FF23391_E165_11D3_AA54_00105A49000B__INCLUDED_)
