#include "stdafx.h"

#include "MainFrm.h"
#include "FileTree.h"
#include "HandleBase.h"
#include "HandleEmpty.h"


CHandleBase::CHandleBase(CFileTree* lpTree,CSplitterWnd* lpSplitter,void* lpData) : 
        m_lpTree(lpTree), m_lpSplitterWnd(lpSplitter), m_lpData(lpData), m_hParentItem(NULL), m_boExpanded(false)
{
    m_szNodeName[0] = 0;
    m_lpTRFile = lpTree->lpGetTRFile();
}


void    CHandleBase::vSetToolboxType()
{
    ((CMainFrame*)AfxGetApp()->m_pMainWnd)->vSetToolboxType(TOOLBOX_EMPTY);
}


void    CHandleBase::vShowEditDialog(bool boCreatePane,TCHAR* lpszNodeName)
{
    lstrcpyn(m_szNodeName,lpszNodeName,256);

    // Need to create the pane ?
    if(boCreatePane)
        {
        // Yes: delete the right pane and recreate it
        m_lpSplitterWnd->DeleteView(0,1);
        vCreatePane();
        m_lpSplitterWnd->RecalcLayout();
        }

    // Give to the right pane (the edit/show view) informations about the node
    vEditSetInfo(lpszNodeName);

    // Show the object toolbox
    vSetToolboxType();
}


void    CHandleBase::vExpandTree(HTREEITEM hItem)
{
    bool boAlreadyExpanded = m_boExpanded;

    if(!m_boExpanded)
        {
        m_boExpanded = true;

        m_hParentItem = hItem;

        HTREEITEM hItemDel = m_lpTree->GetChildItem(m_hParentItem);
        CHandleBase*    lpNode = (CHandleBase*) m_lpTree->GetItemData(hItemDel);
        delete lpNode;

        m_lpTree->DeleteItem(hItemDel);
        }

    lstrcpyn(m_szNodeName,(TCHAR*)(LPCTSTR)m_lpTree->GetItemText(hItem),256);

    vExpandTree(boAlreadyExpanded);
}


void    CHandleBase::vSetChanged()
{
    m_lpTree->vSetChanged();
}


void    CHandleBase::vCollapseTree()
{
    if(!m_boExpanded) return;

    m_boExpanded = false;

    HTREEITEM h;
    CString   s;

    INSERT(m_lpTree,h,m_hParentItem,new CHandleEmpty(m_lpTree,m_lpSplitterWnd))  // Child beneath
}


