#include "stdafx.h"

#include "Resource.h"
#include "FileTree.h"
#include "HandleMeshes.h"
#include "HandleMesh.h"
#include "EditEmpty.h"


void    CHandleMeshes::vCreatePane()
{
    m_lpSplitterWnd->CreateView(0,1,RUNTIME_CLASS(CEditEmpty),CSize(1,1),NULL);
}


void    CHandleMeshes::vExpandTree(bool boAlreadyExpanded)
{
    if(boAlreadyExpanded) return;

    CString             s;
    DWORD               dwI;
    HTREEITEM           h;
    CTRFile*            lpTRFile    = m_lpTree->lpGetTRFile();
    TR_FILE             trFile      = lpTRFile->GetTRFile();
    enumTRType          trType      = lpTRFile->GetTRType();

    TCHAR               szLevelName[20+1];
    
    lstrcpyn(szLevelName,lpTRFile->lpszGetShortLevelName(),20+1);

    switch(trType)
        {
        //
        case TR1_FILE:
        case TR2_FILE:
        case TR3_FILE:
            {
            for(dwI = 0; dwI < trFile.tr123File.dwNumMeshes; dwI++)
                {
                s.Format(_T("%s_MSH%.3d"),szLevelName,dwI);
                INSERT(m_lpTree,h,m_hParentItem,new CHandleMesh(m_lpTree,m_lpSplitterWnd,trFile.tr123File.lplpMeshes[dwI]))
                }
            break;
            }
        }
}


CMenu*  CHandleMeshes::lpGetPopupupMenu(HTREEITEM hSelectedItem)
{
    m_lpMenu = new CMenu;
    m_lpMenu->LoadMenu(IDR_MENU_MESHES);

    return m_lpMenu->GetSubMenu(0);
}


void    CHandleMeshes::vReleasePopupupMenu()
{
    delete m_lpMenu;
    
    m_lpMenu = NULL;
}


void    CHandleMeshes::vHandleMenu(WORD wMenuId)
{
    switch(wMenuId)
        {
        // Export all meshes to .MSH files
        case ID_MESHES_EXPORTASMSH:
            {
            vExportAsMSH();
            break;
            }
        }
}


void    CHandleMeshes::vExportAsMSH()
{
    BROWSEINFO   bi;
    ZeroMemory(&bi,sizeof(BROWSEINFO));

    TCHAR szBuf[MAX_PATH];
    lstrcpy(szBuf, __TEXT("Choose a folder to save the MSH in:"));

    bi.hwndOwner  = NULL;
    bi.ulFlags    = 0;
    bi.lpszTitle  = static_cast<LPCSTR>(szBuf);
    bi.lpfn       = NULL;
    bi.lParam     = (long)this;

    LPITEMIDLIST  pidl = SHBrowseForFolder(&bi);

    if(!pidl) return;

    SHGetPathFromIDList(pidl,szBuf);

    CWaitCursor dummy;

    CTRFile*    lpTRFile    = m_lpTree->lpGetTRFile();
    TR_FILE     trFile      = lpTRFile->GetTRFile();

    CString     s;
    TCHAR       szLevelName[20+1];
    
    lstrcpyn(szLevelName,lpTRFile->lpszGetShortLevelName(),20+1);

    for(DWORD dwI = 0; dwI < trFile.tr123File.dwNumMeshes; dwI++)
        {
        CTrLstMsh  Msh(trFile.tr123File.lplpMeshes[dwI],lpTRFile);

        DWORD   dwMSHSize;
        BYTE*   lpMSH = Msh.lpbGetData(dwMSHSize);

        s.Format(_T("%s\\%s_MSH%.3d.trmsh"),szBuf,szLevelName,dwI);

        DWORD   dwNumWritten;
        HANDLE hFile = CreateFile(s,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,NULL);
    
        WriteFile(hFile,lpMSH,dwMSHSize,&dwNumWritten,NULL);
    
        CloseHandle(hFile);

        delete [] lpMSH;
        }
}
