#include "stdafx.h"

#include "Resource.h"
#include "FileTree.h"
#include "HandleEmpty.h"
#include "HandleMoveables.h"
#include "HandleMoveable.h"
#include "EditEmpty.h"


void    CHandleMoveables::vCreatePane()
{
    m_lpSplitterWnd->CreateView(0,1,RUNTIME_CLASS(CEditEmpty),CSize(1,1),NULL);
}


void    CHandleMoveables::vExpandTree(bool boAlreadyExpanded)
{
    if(boAlreadyExpanded)
        {
        m_lpTree->m_boDeleting = true;
        m_lpTree->vReleaseNode(m_hParentItem,true,true);
        m_lpTree->m_boDeleting = false;
        }

    CString             s;
    DWORD               dwI = 0;
    HTREEITEM           h,hItem;
    CTRFile*            lpTRFile    = m_lpTree->lpGetTRFile();
    TR_FILE             trFile      = lpTRFile->GetTRFile();
    enumTRType          trType      = lpTRFile->GetTRType();

    TCHAR               szLevelName[20+1];
    
    lstrcpyn(szLevelName,lpTRFile->lpszGetShortLevelName(),20+1);

    switch(trType)
        {
        //
        case TR1_FILE:
        case TR2_FILE:
        case TR3_FILE:
            {
            TRListMoveable* lpList = trFile.tr123File.lpListMoveable;
            for(TRListMoveable::iterator theIterator = lpList->begin(); theIterator != lpList->end(); theIterator++)
                {
                s.Format(_T("%s_MVB%.3d"),szLevelName,dwI++);
                INSERT(m_lpTree,hItem,m_hParentItem,new CHandleMoveable(m_lpTree,m_lpSplitterWnd,*theIterator))
                INSERT(m_lpTree,h,hItem,new CHandleEmpty(m_lpTree,m_lpSplitterWnd))
                }
            break;
            }
        }
}


CMenu*  CHandleMoveables::lpGetPopupupMenu(HTREEITEM hSelectedItem)
{
    m_lpMenu = new CMenu;
    m_lpMenu->LoadMenu(IDR_MENU_MOVEABLES);

    return m_lpMenu->GetSubMenu(0);
}


void    CHandleMoveables::vReleasePopupupMenu()
{
    delete m_lpMenu;
    
    m_lpMenu = NULL;
}


void    CHandleMoveables::vHandleMenu(WORD wMenuId)
{
    switch(wMenuId)
        {
        // Load a 3ds file and add a new moveable
        case ID_MOVEABLES_IMPORTFROM3DS:
            {
            vImportFrom3DS();
            break;
            }
        // Add a moveable from a .TRMVB file
        case ID_MOVEABLES_IMPORTFROMTRMVB:
            {
            vImportFromMVB();
            break;
            }
        // Export all meshes to .MVB files
        case ID_MOVEABLES_EXPORTASMVB:
            {
            vExportAsMVB();
            break;
            }
        }
}


void    CHandleMoveables::vExportAsMVB()
{
    BROWSEINFO   bi;
    ZeroMemory(&bi,sizeof(BROWSEINFO));

    TCHAR szBuf[MAX_PATH];
    lstrcpy(szBuf, __TEXT("Choose a folder to save the TRMVB in:"));

    bi.hwndOwner  = NULL;
    bi.ulFlags    = 0;
    bi.lpszTitle  = static_cast<LPCSTR>(szBuf);
    bi.lpfn       = NULL;
    bi.lParam     = (long)this;

    LPITEMIDLIST  pidl = SHBrowseForFolder(&bi);

    if(!pidl) return;

    SHGetPathFromIDList(pidl,szBuf);

    CWaitCursor dummy;

    CTRFile*    lpTRFile    = m_lpTree->lpGetTRFile();
    TR_FILE     trFile      = lpTRFile->GetTRFile();

    CString     s;
    TCHAR       szLevelName[20+1];
    DWORD       dwI = 0;
    
    lstrcpyn(szLevelName,lpTRFile->lpszGetShortLevelName(),20+1);

    TRListMoveable* lpList = trFile.tr123File.lpListMoveable;
    for(TRListMoveable::iterator theIterator = lpList->begin(); theIterator != lpList->end(); theIterator++)
        {
        CTrMvb*  lpMvb = *theIterator;

        DWORD   dwMVBSize;
        BYTE*   lpMVB = lpMvb->lpbGetData(dwMVBSize);

        s.Format(_T("%s\\%s_MVB%.3d.trmvb"),szBuf,szLevelName,dwI++);

        DWORD   dwNumWritten;
        HANDLE hFile = CreateFile(s,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,NULL);
    
        WriteFile(hFile,lpMVB,dwMVBSize,&dwNumWritten,NULL);
    
        CloseHandle(hFile);

        delete [] lpMVB;
        }
}


//
//
// Import a moveable from a .3DS
//
//
void    CHandleMoveables::vImportFrom3DS()
{
    BYTE* lpData = NULL;

    // Load the 3DS file
    CString strFilter(_T("3DS files (*.3ds)|*.3ds||"));
    CFileDialog FileDialog(TRUE,_T(""),_T(""),OFN_HIDEREADONLY,strFilter);

    if(FileDialog.DoModal() != IDOK) return;

    CWaitCursor dummy;

    CTRFile* lpTRFile = m_lpTree->lpGetTRFile();

    // NOT IMPLEMENTED
}


//
//
// Import a moveable from a .TRMVB
//
//
void    CHandleMoveables::vImportFromMVB()
{
    // Load the MVB file
    CString strFilter = _T("TR Moveable files (*.trmvb)|*.trmvb||");

    CFileDialog FileDialog(TRUE,_T(""),_T(""),OFN_HIDEREADONLY,strFilter);

    if(FileDialog.DoModal() != IDOK) return;

    CWaitCursor dummy;

    CTRFile* lpTRFile = m_lpTree->lpGetTRFile();

    CTrMvb Mvb = CTrMvb::objLoad(FileDialog.GetPathName());

    CTrMvb* lpMvb = new CTrMvb;

    lpMvb->vStealData(Mvb);

    lpTRFile->GetTRFile().tr123File.lpListMoveable->push_back(lpMvb);

    vSetChanged();

    if(m_boExpanded)
        {
        vExpandTree(true);
        }
}
