#include "stdafx.h"

#include "Resource.h"
#include "FileTree.h"
#include "HandleRootTR123.h"
#include "HandleEmpty.h"
#include "HandleStaticMeshes.h"
#include "HandleMoveables.h"
#include "HandleSprites.h"
#include "EditEmpty.h"


void    CHandleRootTR123::vCreatePane()
{
    m_lpSplitterWnd->CreateView(0,1,RUNTIME_CLASS(CEditEmpty),CSize(1,1),NULL);
}


void    CHandleRootTR123::vExpandTree(bool boAlreadyExpanded)
{
    if(boAlreadyExpanded) return;

    CString             s;
    HTREEITEM           hItem, h;
    CTRFile*            lpTRFile    = m_lpTree->lpGetTRFile();
    TR_FILE&            trFile      = lpTRFile->GetTRFile();
    enumTRType          trType      = lpTRFile->GetTRType();

    m_lpTree->m_lpHandleMoveables = new CHandleMoveables(m_lpTree,m_lpSplitterWnd);

    s.Format("Moveables");
    INSERT(m_lpTree,hItem,m_hParentItem,m_lpTree->m_lpHandleMoveables)
    INSERT(m_lpTree,h,hItem,new CHandleEmpty(m_lpTree,m_lpSplitterWnd))  // Child beneath

    m_lpTree->m_lpHandleStaticMeshes = new CHandleStaticMeshes(m_lpTree,m_lpSplitterWnd);

    s.Format("Static meshes");
    INSERT(m_lpTree,hItem,m_hParentItem,m_lpTree->m_lpHandleStaticMeshes)
    INSERT(m_lpTree,h,hItem,new CHandleEmpty(m_lpTree,m_lpSplitterWnd))  // Child beneath

    m_lpTree->m_lpHandleSprites = new CHandleSprites(m_lpTree,m_lpSplitterWnd);

    s.Format("Sprites");
    INSERT(m_lpTree,hItem,m_hParentItem,m_lpTree->m_lpHandleSprites)
    INSERT(m_lpTree,h,hItem,new CHandleEmpty(m_lpTree,m_lpSplitterWnd))  // Child beneath
}

