#pragma once

#include "HandleBase.h"

typedef enum { TILE_256x256_16, TILE_256xY_32, TILE_256xY_16 } enumTileType;

class CHandleTile : public CHandleBase
{
public:

    CHandleTile(CFileTree* lpTree,CSplitterWnd* lpSplitter,void* lpData,enumTileType TileType) : CHandleBase(lpTree,lpSplitter,lpData),m_TileType(TileType),m_lpMenu(NULL) { }
    DWORD           dwGetDataType() { return 2; }
    enumTileType    GetTileType() { return m_TileType; }
    void*           GetTile() { return lpGetData(); }
    virtual void    vCopyTo(CHandleBase* lpDst,bool boCopyInSameLevel);

    virtual CMenu*  lpGetPopupupMenu(HTREEITEM hSelectedItem);
    virtual void    vReleasePopupupMenu();
    virtual void    vHandleMenu(WORD wMenuId);

protected:

    virtual void vCreatePane();
    virtual void vEditSetInfo(TCHAR* lpszNodeName,bool boForceNew = false);
    void         vReplaceTile();
    void         vExportToTGA();

private:

    enumTileType    m_TileType;
    CMenu*          m_lpMenu;
};