#if !defined(AFX_OPENGLWND1_H__D75C4CE2_F1E2_11D3_AA63_00105A49000B__INCLUDED_)
#define AFX_OPENGLWND1_H__D75C4CE2_F1E2_11D3_AA63_00105A49000B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OpenGLWnd1.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COpenGLWnd window

#include <GL/gl.h>     // OpenGL interface
#include <GL/glu.h>    // OpenGL utility Library interface

#include "Camera.h"

class CToolboxMoveable;

class COpenGLWnd : public CWnd
{
// Construction
public:
	COpenGLWnd();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COpenGLWnd)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COpenGLWnd();
    void    vSetGfxAddr(CTrLstMsh* lpTrMsh,enumTrObjType trObjType,bool boDontReleaseTextures = false,DWORD dwNumMeshToRender = 0);
    void    vSetSprSeqAddr(CTrLstSpr* lpSprSeq,bool boDontReleaseTextures = false);
    void    vSetMoveableAnimation(DWORD dwNumAnim);
    void    vActivateWnd();
    void    vCheckKeys();
    void    vSetAutomaticCamera(bool boOk);
    void    vSetShowAxis(bool boOk);
    void    vSetBkgColor(COLORREF BkgColor);
    void    vSetShowCollSphere(bool boOk) { m_boShowCollSphere = boOk; InvalidateRect(NULL); }
    void    vSetShowVertices(bool boOk) { m_boShowVertices = boOk; InvalidateRect(NULL); }
    void    vSetShowStaticBB1(bool boOk) { m_boShowStaticBB1 = boOk; InvalidateRect(NULL); }
    void    vSetStaticBB1IsSel(bool boOk) { m_boStaticBB1IsSel = boOk; InvalidateRect(NULL); }
    void    vSetShowStaticBB2(bool boOk) { m_boShowStaticBB2 = boOk; InvalidateRect(NULL); }
    void    vSetStaticBB2IsSel(bool boOk) { m_boStaticBB2IsSel = boOk; InvalidateRect(NULL); }
    void    vReleaseTextures();
    void    vPick(DWORD dwPosX,DWORD dwPosY);
    float   fGetFrameRate() { return m_fFrameRate; }
    void    vModifyIntensOfSelectedVertices(bit16 sStep);
    void    vSetAnimationType(bool boChainAnimations,bool boResetMoveable);
    void    vSetAutomaticAnim(bool boOk) { m_boAutomaticAnim = boOk; }
    void    vSetAnimOverallSpeed(float fSpeed);
    void    vSetAnimCurFrame(DWORD dwNumFrame);
    void    vSetAnimCurKey(DWORD dwNumKey);
    void    vSetAnimInterp(bool boOk);
    void    vChangeAnimInterp(int iDir);
    void    vSetAnimInterp(float fInterp);
    void    vSetSprSeqOverallSpeed(float fSpeed) { m_fSprSeqSpeed = fSpeed; }
    void    vSetSprSeqShowBorder(bool boShow) {  m_boSprSeqShowBorder = boShow; }
    void    vSetSprSeqTypeAnimated(bool boAnimated) {  m_boSprSeqTypeAnimated = boAnimated; }
    void    vSetSprSeqListWidth(float fListWidth) {  m_fSprSeqListWidth = fListWidth; }

	void    OnLButtonDown(UINT nFlags, CPoint point);
	void    OnLButtonUp(UINT nFlags, CPoint point);
	void    OnRButtonDown(UINT nFlags, CPoint point);
	void    OnRButtonUp(UINT nFlags, CPoint point);
	void    OnLButtonDblClk(UINT nFlags, CPoint point);
	void    OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	void    OnMouseMove(UINT nFlags, CPoint point);

protected:
	// Generated message map functions
	//{{AFX_MSG(COpenGLWnd)
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

    void    vChangeSize(int cx, int cy);
    void    vDraw(HDC hDC);
    void    vGenerateTextures();
    void    vRenderMesh(CTrLstMsh* lpTrMsh,DWORD dwNumMesh,bool boShowCollisionSphere = false,bool boWireframe = false,bool boShowVertices = false);
    void    vRenderMoveable(CTrMvb* lpTrMvb);
    void    vRenderSprite(const WORLD_POSITIONNING* lpWorldP,const TR2_OBJECT_TEXTURE* lpText,bool boAlign = false);
    void    vRenderSprSeq(CTrLstSpr* lpSprSeq);
    void    vInitiateCamera(float fMinX,float fMaxX,float fMinY,float fMaxY,float fMinZ,float fMaxZ, bool boCenterCamera = false);
    void    vRenderMeshVertices(const TR123_MESH* lpMesh);

    HGLRC               m_hRC;
    HDC                 m_hDC;
    bool                m_boMakeCurrentOk;
    GLdouble            m_gldAspect;
    GLuint*             m_LstTextId;
    CToolboxMoveable*   m_lpToolbox;
    bool                m_boShowAxis;
    COLORREF            m_BkgColor;

    enumTrObjType       m_trObjType;
    CTrLstMsh*          m_lpTrGfx;

    bool                m_boShowCollSphere;
    bool                m_boShowVertices;
    bool                m_boShowStaticBB1;
    bool                m_boStaticBB1IsSel;
    bool                m_boShowStaticBB2;
    bool                m_boStaticBB2IsSel;
    DWORD               m_dwNumMeshToRender;
    float               m_fMax;

    DWORD               m_dwOldTime;
    LARGE_INTEGER       m_OldTime;
    float               m_fFrameRate;

    CAMERA              m_Camera;
    bool                m_boAutomaticCamera;

    bool                m_boPickingMode;
    DWORD               m_dwShowNumVertex;

    bool                m_boAutomaticAnim;
    bool                m_boAnimShow;
    bool                m_boChainAnimations;
    bool                m_boAnimInterp;
    bool                m_boRecalcInterp;
    DWORD               m_dwAnimCurAnim;
    FLOAT               m_fAnimOverallSpeed;

    float               m_fSprSeqSpeed;
    bool                m_boSprSeqShowBorder;
    bool                m_boSprSeqTypeAnimated;
    float               m_fSprSeqListWidth;

    bool                m_boRotWithMouse;
    CPoint              m_RotMousePos;
    bool                m_boTransWithMouse;
    CPoint              m_TransMousePos;

    CTrLstSpr*          m_lpSprSeq;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPENGLWND1_H__D75C4CE2_F1E2_11D3_AA63_00105A49000B__INCLUDED_)
