#include "stdafx.h"


void    vMakeTGA32Bits(const TCHAR* lpszFileName,BYTE* lpBuffer,DWORD dwWidth,DWORD dwHeight,DWORD dwNumBytesPerTexel,bool boReverse)
{
    unsigned char TGAHeader[] = {0,0,2,0,0,0,0,0,0,0,0,0,64,1,200,0,32,0};

    DWORD dwNb    = dwWidth * dwHeight;

    *((WORD*)&TGAHeader[12]) = (WORD)dwWidth;
    *((WORD*)&TGAHeader[14]) = (WORD)dwHeight;

    FILE* ff = _tfopen(lpszFileName,_T("wb"));
    fwrite(TGAHeader,1,sizeof(TGAHeader),ff);

    for(DWORD j = 0; j < dwHeight; j++)
        {
        BYTE* lpb;
        
        if(boReverse)   lpb = lpBuffer + (dwHeight-j-1) * dwWidth * dwNumBytesPerTexel;
        else            lpb = lpBuffer + j * dwWidth * dwNumBytesPerTexel;

        for(DWORD i = 0; i < dwWidth; i++)
            {
            BYTE    bARGB[4];
            memcpy(bARGB,lpb,dwNumBytesPerTexel);
            if(dwNumBytesPerTexel == 3) bARGB[3] = 255;
            fwrite(bARGB,1,4,ff);
            lpb += dwNumBytesPerTexel;
            }
        }

    fclose(ff);
}


void    vMakeTGA16Bits(const TCHAR* lpszFileName,BYTE* lpBuffer,DWORD dwWidth,DWORD dwHeight,DWORD dwNumBytesPerTexel,bool boReverse)
{
    unsigned char TGAHeader[] = {0,0,2,0,0,0,0,0,0,0,0,0,64,1,200,0,16,0};

    DWORD dwNb    = dwWidth * dwHeight;

    *((WORD*)&TGAHeader[12]) = (WORD)dwWidth;
    *((WORD*)&TGAHeader[14]) = (WORD)dwHeight;

    FILE* ff = _tfopen(lpszFileName,_T("wb"));
    fwrite(TGAHeader,1,sizeof(TGAHeader),ff);

    for(DWORD j = 0; j < dwHeight; j++)
        {
        BYTE* lpb;
        
        if(boReverse)   lpb = lpBuffer + (dwHeight-j-1) * dwWidth * dwNumBytesPerTexel;
        else            lpb = lpBuffer + j * dwWidth * dwNumBytesPerTexel;

        for(DWORD i = 0; i < dwWidth; i++)
            {
            fwrite(lpb,1,2,ff);
            lpb += dwNumBytesPerTexel;
            }
        }

    fclose(ff);
}


