#include "stdafx.h"

#include "AnimData.h"
#include "AnimKey.h"
#include "AnimTrack.h"
#include "TRAnimTrack.h"


CTRAnimCommand::CTRAnimCommand(TR2_ANIM_COMMAND* lpsData, DWORD dwFrameStart /*= -1*/)
{
    m_sCommand = *lpsData++;

    m_wNumParams = -1;

    bool boFirstParamIsFrame = false;

    switch(m_sCommand.sValue)
        {
        // 1
        case ANIMCMD_POSITIONREF3_3:
            {
            m_wNumParams = 3;
            break;
            }
        // 2
        case ANIMCMD_POSITIONREF2_2:
            {
            m_wNumParams = 2;
            break;
            }
        // 3
        case ANIMCMD_SLAVEANIM_0:
            {
            m_wNumParams = 0;
            break;
            }
        // 4
        case ANIMCMD_DEATHANIM_0:
            {
            m_wNumParams = 0;
            break;
            }
        // 5
        case ANIMCMD_PLAYSOUNDONFRAME_2:
            {
            boFirstParamIsFrame = true;
            m_wNumParams = 2;
            break;
            }
        // 6
        case ANIMCMD_MISCACTIONONFRAME_2:
            {
            boFirstParamIsFrame = true;
            switch(lpsData[1].sValue)
                {

                case ANIMCMD_MISC_REVERTCAMERA:
                case ANIMCMD_MISC_UNK6:
                case ANIMCMD_MISC_UNK0:
                case ANIMCMD_MISC_MAKEBUBBLE:
                case ANIMCMD_MISC_REACTIVATEACTIONKEY:
                case ANIMCMD_MISC_CAMERACTRL1:
                case ANIMCMD_MISC_CAMERACTRL2:
                case ANIMCMD_MISC_UNK1:
                case ANIMCMD_MISC_UNK2:
                case ANIMCMD_MISC_LARACHANGECLOTH:
                case ANIMCMD_MISC_UNK3:
                case ANIMCMD_MISC_UNK4:
                case ANIMCMD_MISC_HIDEOBJECT:
                case ANIMCMD_MISC_SHOWOBJECT:
                case ANIMCMD_MISC_CAMERACTRL3:
                case ANIMCMD_MISC_ADDITIONALSOUND1:
                case ANIMCMD_MISC_UNK5:
                case ANIMCMD_MISC_ADDITIONALSOUND2:
                    {
                    m_wNumParams = 2;
                    break;
                    }
                }
            break;
            }
        }

    ASSERT(m_wNumParams < ANIMCMD_NUMMAX_PARAMS);

    if(m_wNumParams != -1)
        {
        for(WORD wI = 0; wI < m_wNumParams; wI++)
            {
            m_sParams[wI] = *lpsData++;
            if(wI == 0  &&  boFirstParamIsFrame  &&  dwFrameStart != -1) m_sParams[0].sValue -= dwFrameStart;
            }
        }
    else
        {
        CString s;

        s.Format(_T("Command %ld unknown in Anim commands list !!"),(long)m_sCommand.sValue);
        AfxMessageBox(s);

        abort();
        }
}


const CTRStateChange& CTRAnimTrack::GetStateChangeFromStateId(DWORD dwStateId) const
{
    DWORD dwIndex = -1;

    for(DWORD dwStateChange = 0; dwStateChange < dwGetNumStateChanges(); dwStateChange++)
        {
        if(m_ListStateChanges[dwStateChange].dwGetStateId() == dwStateId)
            {
            dwIndex = dwStateChange;
            break;
            }
        }

    ASSERT(dwIndex != -1);

    return m_ListStateChanges[dwIndex];
}


DWORD CTRAnimTrack::dwGetNumAnimDispatches() const
{
    DWORD dwNum = 0;

    for(DWORD dwStateChange = 0; dwStateChange < dwGetNumStateChanges(); dwStateChange++)
        {
        dwNum += m_ListStateChanges[dwStateChange].dwGetNumAnimDispatch();
        }

    return dwNum;
}


DWORD CTRAnimTrack::dwGetNumParamsAnimCommands() const
{
    DWORD dwNum = 0;

    for(DWORD dwAnimCommand = 0; dwAnimCommand < dwGetNumAnimCommands(); dwAnimCommand++)
        {
        dwNum += m_ListAnimCommands[dwAnimCommand].wGetNumParams() + 1;
        }

    return dwNum;
}
