#include "stdafx.h"

#include "3DSStuff.h"
#include "TGAFile.h"
#include "TextureTools.h"

//#define EXPORTMSH_256x256_TEXTURE

void CTRFile::vCopy3DSMeshIntoTRMesh(TR123_MESH* lpMesh,database3ds* db,mesh3ds* lpMesh3ds,DWORD& dwIdxVert,DWORD& dwIdxTriMap,MATNAME2INFO* lpMapMat)
{
    DWORD dwCurIdxVert      = dwIdxVert;
    DWORD dwCurIdxTriMap    = dwIdxTriMap;

    for(DWORD dwJ = 0; dwJ < lpMesh3ds->nvertices; dwJ++)
        {
        lpMesh->lpVertices[dwIdxVert].sX =  (bit16)lpMesh3ds->vertexarray[dwJ].x;
        lpMesh->lpVertices[dwIdxVert].sY = -(bit16)lpMesh3ds->vertexarray[dwJ].z;
        lpMesh->lpVertices[dwIdxVert].sZ =  (bit16)lpMesh3ds->vertexarray[dwJ].y;
        dwIdxVert++;
        }

    if(!lpMapMat) return;

    for(dwJ = 0; dwJ < lpMesh3ds->nmats; dwJ++)
        {
        MATNAME2INFO::iterator theIter = lpMapMat->find(lpMesh3ds->matarray[dwJ].name);
        INFO_MAT* lpInfo = theIter->second;

        DWORD dwNumFaces = lpMesh3ds->matarray[dwJ].nfaces;
        if(dwNumFaces)
            {
            INFO_MESH_MAT* lpMeshMat = new INFO_MESH_MAT;

            lpInfo->boUsed = true;
            lpInfo->ListMeshMat.push_back(lpMeshMat);

            lpMeshMat->lpLstTextCoord = new TR2_OBJECT_TEXTURE[dwNumFaces];
            lpMeshMat->dwNumObjText = dwNumFaces;
            lpMeshMat->dwNumTris = dwNumFaces;
            lpMeshMat->dwStartTriIndex = dwIdxTriMap;
            lpMeshMat->dwNumQuads = 0;
            lpMeshMat->dwStartQuadIndex = 0;
            lpMeshMat->lpMesh = lpMesh;
            lpMeshMat->boUseWordArray = false;
            lpMeshMat->dwWordArraySize = 0;
            lpMeshMat->lplpWordArray = NULL;

            for(DWORD dwK = 0; dwK < dwNumFaces; dwK++)
                {
                DWORD dwIdx = lpMesh3ds->matarray[dwJ].faceindex[dwK];
                lpMesh->lpTexturedTriangles[dwIdxTriMap].awVertices[2] = (bitu16)(lpMesh3ds->facearray[dwIdx].v1+dwCurIdxVert);
                lpMesh->lpTexturedTriangles[dwIdxTriMap].awVertices[1] = (bitu16)(lpMesh3ds->facearray[dwIdx].v2+dwCurIdxVert);
                lpMesh->lpTexturedTriangles[dwIdxTriMap].awVertices[0] = (bitu16)(lpMesh3ds->facearray[dwIdx].v3+dwCurIdxVert);
                lpMesh->lpTexturedTriangles[dwIdxTriMap].wTextureIndex = dwK;
                lpMeshMat->lpLstTextCoord[dwK].wTile = 0;
                lpMeshMat->lpLstTextCoord[dwK].wAttribute = 0;
                lpMeshMat->lpLstTextCoord[dwK].Vertices[2].cXCoordinate = 0;
                lpMeshMat->lpLstTextCoord[dwK].Vertices[2].cYCoordinate = 0;
                lpMeshMat->lpLstTextCoord[dwK].Vertices[2].bXPixel = (BYTE) (lpMesh3ds->textarray[lpMesh3ds->facearray[dwIdx].v1].u * (lpInfo->dwWidth-1));
                lpMeshMat->lpLstTextCoord[dwK].Vertices[2].bYPixel = (BYTE) ((1.0f - lpMesh3ds->textarray[lpMesh3ds->facearray[dwIdx].v1].v) * (lpInfo->dwHeight-1));
                lpMeshMat->lpLstTextCoord[dwK].Vertices[1].cXCoordinate = 0;
                lpMeshMat->lpLstTextCoord[dwK].Vertices[1].cYCoordinate = 0;
                lpMeshMat->lpLstTextCoord[dwK].Vertices[1].bXPixel = (BYTE) (lpMesh3ds->textarray[lpMesh3ds->facearray[dwIdx].v2].u * (lpInfo->dwWidth-1));
                lpMeshMat->lpLstTextCoord[dwK].Vertices[1].bYPixel = (BYTE) ((1.0f - lpMesh3ds->textarray[lpMesh3ds->facearray[dwIdx].v2].v) * (lpInfo->dwHeight-1));
                lpMeshMat->lpLstTextCoord[dwK].Vertices[0].cXCoordinate = 0;
                lpMeshMat->lpLstTextCoord[dwK].Vertices[0].cYCoordinate = 0;
                lpMeshMat->lpLstTextCoord[dwK].Vertices[0].bXPixel = (BYTE) (lpMesh3ds->textarray[lpMesh3ds->facearray[dwIdx].v3].u * (lpInfo->dwWidth-1));
                lpMeshMat->lpLstTextCoord[dwK].Vertices[0].bYPixel = (BYTE) ((1.0f - lpMesh3ds->textarray[lpMesh3ds->facearray[dwIdx].v3].v) * (lpInfo->dwHeight-1));
                ZeroMemory(&lpMeshMat->lpLstTextCoord[dwK].Vertices[3],sizeof(TR2_OBJECT_TEXTURE_VERT));
                dwIdxTriMap++;
                }
            }
        }
}


bool CTRFile::boImportMeshFrom3DS(TR123_MESH* lpMesh,TCHAR* lpsz3DSName,bool boInternalLighting)
{
    bool    boOk = false;

    // Get the path to the textures
    TCHAR szDrive[_MAX_DRIVE];
    TCHAR szDir[_MAX_DIR];
    TCHAR szPath[_MAX_PATH];

    _tsplitpath(lpsz3DSName,szDrive,szDir,NULL,NULL);

    lstrcpy(szPath,szDrive);
    lstrcat(szPath,szDir);
    
    // Read the 3DS file
    file3ds*        file= NULL;
    database3ds*    db = NULL;

    file = OpenFile3ds(lpsz3DSName, "rw");
    ON_ERROR_PRINT

    InitDatabase3ds(&db);
    ON_ERROR_PRINT

    CreateDatabase3ds(file, db);
    ON_ERROR_PRINT

    // Create the material list
    MATNAME2INFO    MapMat;

    vCreateMapMaterial(db,MapMat,szPath);

    // Calculate the number of vertices / triangles
    DWORD dwNumMeshes = GetMeshCount3ds(db);
    DWORD dwNumVert = 0;
    DWORD dwNumTris = 0;

    for(DWORD dwI = 0; dwI < dwNumMeshes; dwI++)
        {
        mesh3ds* lpMesh3ds = NULL;
        GetMeshByIndex3ds(db,dwI,&lpMesh3ds);

        if(lpMesh3ds)
            {
            dwNumVert += lpMesh3ds->nvertices;
            dwNumTris += lpMesh3ds->nfaces;
            }

        RelMeshObj3ds(&lpMesh3ds);
        }

    vInitializeMesh(lpMesh,dwNumVert,dwNumTris,0,boInternalLighting,m_TRType == TR3_FILE);

    // Parse the 3ds meshes and copy them into lpMesh
    DWORD dwIdxVert     = 0;
    DWORD dwIdxTriMap   = 0;    // Number of textured triangles

    for(dwI = 0; dwI < dwNumMeshes; dwI++)
        {
        mesh3ds* lpMesh3ds = NULL;
        GetMeshByIndex3ds(db,dwI,&lpMesh3ds);

        if(lpMesh3ds)
            {
            vCopy3DSMeshIntoTRMesh(lpMesh,db,lpMesh3ds,dwIdxVert,dwIdxTriMap,&MapMat);
            RelMeshObj3ds(&lpMesh3ds);
            }
        }

    // Update data of the mesh (reallocate triangles array / compute point normals & collision sphere)
    vUpdateMeshData(lpMesh,dwIdxTriMap,boInternalLighting);

    // Add new tiles / object textures to the level
    vUpdateTextureData(MapMat);

    boOk = true;

    ReleaseDatabase3ds(&db);
    ON_ERROR_PRINT

    CloseFile3ds(file);
    ON_ERROR_PRINT

    CloseAllFiles3ds();

    return boOk;
}


bool    boCopyTRMeshInto3DSMesh(database3ds* Db3ds,char* lpszObjName,
            CTrLstMsh& trObj,TR123_MESH* lpMesh,char* lpszTextureName,
            float& fMinX,float& fMaxX,float& fMinY,float& fMaxY,float& fMinZ,float& fMaxZ,
            float fTransX, float fTransY, float fTransZ)
{
    //
    // Objects
    //
    short sNumVertices              = lpMesh->sNumVertices;
    short sNumTexturedRectangles    = lpMesh->sNumTexturedRectangles;
    short sNumTexturedTriangles     = lpMesh->sNumTexturedTriangles;
    WORD  wNumTexturedTris          = sNumTexturedTriangles + 2 * sNumTexturedRectangles;
    WORD  wNumTris                  = wNumTexturedTris;
    WORD  wFaceIndex                = 0;
    WORD  wVertIndex                = 0;

    if(!wNumTris  ||  !sNumVertices)
        {
        return false;
        }

    // Init the 3DS mesh
    mesh3ds*    lpObj           = NULL;
    InitMeshObj3ds(&lpObj, wNumTris * 3, wNumTris, InitTextArray3ds);

    ON_ERROR_RETURNR(false)
    wsprintf(lpObj->name,"%s",lpszObjName);

    lpObj->nmats = (unsigned short)1;
    lpObj->matarray = new objmat3ds [lpObj->nmats];

    // Material for the texture
    strcpy(lpObj->matarray[0].name,"tile0");
    lpObj->matarray[0].nfaces = 0;
    lpObj->matarray[0].faceindex = new ushort3ds[wNumTexturedTris];

    //
    float fU,fV;

#ifdef EXPORTMSH_256x256_TEXTURE
    float fUMax = 255;
    float fVMax = 255;
#else
    float fUMax = trObj.m_dwTextureWidth - 1;
    float fVMax = trObj.m_dwTextureHeight - 1;
#endif

    while(sNumTexturedRectangles--)
        {
        bitu16* lpFace = lpMesh->lpTexturedRectangles[sNumTexturedRectangles].awVertices;
        TR2_OBJECT_TEXTURE* lpTexture   = &trObj.m_lpFragText[lpMesh->lpTexturedRectangles[sNumTexturedRectangles].wTextureIndex];
        bitu16  wNumTile                = lpTexture->wTile;
        TR2_OBJECT_TEXTURE_VERT* lpVertTexture = (TR2_OBJECT_TEXTURE_VERT*)lpTexture->Vertices;

        lpObj->matarray[wNumTile].nfaces++;
        lpObj->matarray[wNumTile].faceindex[lpObj->matarray[wNumTile].nfaces-1] = wFaceIndex;
        COMPUTE_UV(2);
        SETVERTEX_OBJ_TEXT(lpFace[2],wVertIndex+0,(fU / fUMax),(fV / fVMax))
        COMPUTE_UV(1);
        SETVERTEX_OBJ_TEXT(lpFace[1],wVertIndex+1,(fU / fUMax),(fV / fVMax))
        COMPUTE_UV(0);
        SETVERTEX_OBJ_TEXT(lpFace[0],wVertIndex+2,(fU / fUMax),(fV / fVMax))
        SetFace(lpObj->facearray[wFaceIndex], wVertIndex+0, wVertIndex+1, wVertIndex+2, FaceABVisable3ds | FaceBCVisable3ds | FaceCAVisable3ds);

        wVertIndex += 3;
        wFaceIndex++;

        lpObj->matarray[wNumTile].nfaces++;
        lpObj->matarray[wNumTile].faceindex[lpObj->matarray[wNumTile].nfaces-1] = wFaceIndex;
        COMPUTE_UV(2);
        SETVERTEX_OBJ_TEXT(lpFace[2],wVertIndex+0,(fU / fUMax),(fV / fVMax))
        COMPUTE_UV(0);
        SETVERTEX_OBJ_TEXT(lpFace[0],wVertIndex+1,(fU / fUMax),(fV / fVMax))
        COMPUTE_UV(3);
        SETVERTEX_OBJ_TEXT(lpFace[3],wVertIndex+2,(fU / fUMax),(fV / fVMax))
        SetFace(lpObj->facearray[wFaceIndex], wVertIndex+0, wVertIndex+1, wVertIndex+2, FaceABVisable3ds | FaceBCVisable3ds | FaceCAVisable3ds);

        wVertIndex += 3;
        wFaceIndex++;
        }

    while(sNumTexturedTriangles--)
        {
        bitu16* lpFace                  = lpMesh->lpTexturedTriangles[sNumTexturedTriangles].awVertices;
        TR2_OBJECT_TEXTURE* lpTexture   = &trObj.m_lpFragText[lpMesh->lpTexturedTriangles[sNumTexturedTriangles].wTextureIndex];
        bitu16  wNumTile                = lpTexture->wTile;
        TR2_OBJECT_TEXTURE_VERT* lpVertTexture = (TR2_OBJECT_TEXTURE_VERT*)lpTexture->Vertices;

        lpObj->matarray[wNumTile].nfaces++;
        lpObj->matarray[wNumTile].faceindex[lpObj->matarray[wNumTile].nfaces-1] = wFaceIndex;
        COMPUTE_UV(2);
        SETVERTEX_OBJ_TEXT(lpFace[2],wVertIndex+0,(fU / fUMax),(fV / fVMax))
        COMPUTE_UV(1);
        SETVERTEX_OBJ_TEXT(lpFace[1],wVertIndex+1,(fU / fUMax),(fV / fVMax))
        COMPUTE_UV(0);
        SETVERTEX_OBJ_TEXT(lpFace[0],wVertIndex+2,(fU / fUMax),(fV / fVMax))
        SetFace(lpObj->facearray[wFaceIndex], wVertIndex+0, wVertIndex+1, wVertIndex+2, FaceABVisable3ds | FaceBCVisable3ds | FaceCAVisable3ds);

        wVertIndex += 3;
        wFaceIndex++;
        }

    FillMatrix3ds(lpObj);

    lpObj->locmatrix[9] = fTransX;
    lpObj->locmatrix[10] = fTransZ;
    lpObj->locmatrix[11] = -fTransY;

    PutMesh3ds(Db3ds, lpObj);

    ON_ERROR_RETURNR(false)
    RelMeshObj3ds(&lpObj);

    ON_ERROR_RETURNR(false)

    return true;
}


bool    boExportMSHTo3DS(CTrLstMsh& trMSH,DWORD dwNumMesh,TCHAR* lpsz3DSName,TCHAR* lpszTextureName)
{
    TCHAR lpszObjName[_MAX_FNAME];
    TCHAR szDrive[_MAX_DRIVE];
    TCHAR szDir[_MAX_DIR];

    _tsplitpath(lpsz3DSName,szDrive,szDir,lpszObjName,NULL);

    TCHAR szFileName[MAX_PATH];
    TCHAR szTexturePath[MAX_PATH];
    CString s;
    bool    boOk = false;

    _tmakepath(szTexturePath,szDrive,szDir,lpszTextureName,_T(".tga"));

    database3ds* Db3ds = NULL;

    Init3DSForSave(&Db3ds);

    wsprintf(szFileName,__TEXT("%s"),lpsz3DSName);

    lstrcpy(lpszObjName,_T("M"));

    float fMinX = 1e20f, fMaxX = -1e20f;
    float fMinY = 1e20f, fMaxY = -1e20f;
    float fMinZ = 1e20f, fMaxZ = -1e20f;

    CREATE_MATERIAL_FOR_TILE()

    if(boCopyTRMeshInto3DSMesh(Db3ds,lpszObjName,trMSH,&trMSH.m_lpLstMeshes[dwNumMesh],lpszTextureName,fMinX,fMaxX,fMinY,fMaxY,fMinZ,fMaxZ,0.0,0.0,0.0))
        {
        //
        // Lights
        //
        light3ds*       lpSlite = NULL;

        PUT_LIGHT(fMinX,fMinY,fMaxZ,0.5f,"Light1")
        PUT_LIGHT(fMaxX,fMinY,fMaxZ,0.5f,"Light2")
        PUT_LIGHT(fMaxX,fMaxY,fMaxZ,0.5f,"Light3")
        PUT_LIGHT(fMinX,fMaxY,fMaxZ,0.5f,"Light4")

        //
        // Texture
        //

#ifdef EXPORTMSH_256x256_TEXTURE
        BYTE* lpbData = NULL;

        if(trMSH.m_dwTextureDepth == 16)
            {
            lpbData = new BYTE [ 256 * 256 * 4 ];
            ZeroMemory(lpbData, 256 * 256 * 4);
            vPromoteTo32Bits(trMSH.m_lpbTextureData,256,256,16,NULL,lpbData,FALSE,trMSH.m_dwTextureWidth,trMSH.m_dwTextureHeight);
            }
        else
            {
            lpbData = lpbEnlarge32BitsBitmap(trMSH.m_lpbTextureData,trMSH.m_dwTextureWidth,trMSH.m_dwTextureHeight,256,256);
            }

        vMakeTGA32Bits(szTexturePath,lpbData,256,256,4,true);

        delete [] lpbData;
#else
        if(trMSH.m_dwTextureDepth == 16)
            vMakeTGA16Bits(szTexturePath,trMSH.m_lpbTextureData,trMSH.m_dwTextureWidth,trMSH.m_dwTextureHeight,2,true);
        else
            vMakeTGA32Bits(szTexturePath,trMSH.m_lpbTextureData,trMSH.m_dwTextureWidth,trMSH.m_dwTextureHeight,4,true);
#endif
        }

    Save3DS(&Db3ds,szFileName);

    return true;
}
