// ToolboxMesh.cpp : implementation file
//

#include "stdafx.h"
#include "trviewer.h"
#include "MainFrm.h"
#include "EditMesh.h"
#include "HandleMesh.h"
#include "ToolboxMesh.h"


/////////////////////////////////////////////////////////////////////////////
// CToolboxMesh dialog


CToolboxMesh::CToolboxMesh(CWnd* pParent /*=NULL*/)
	
{
    CDialog(CToolboxMesh::IDD, pParent);

	//{{AFX_DATA_INIT(CToolboxMesh)
	m_lCollSphereRadius = 0;
	m_cstrNumQuads      = _T("");
	m_cstrNumTris       = _T("");
	m_cstrNumVert       = _T("");
	m_lBB1x = 0;
	m_lBB1y = 0;
	m_lBB1z = 0;
	m_lBB2x = 0;
	m_lBB2y = 0;
	m_lBB2z = 0;
	m_cstrExtents = _T("");
	m_boBB1On = FALSE;
	m_boBB2On = FALSE;
	m_boFlagCollide = FALSE;
	m_boFlagVisible = FALSE;
	m_cstrObjId = _T("");
	m_boDummyMesh = FALSE;
	m_boIntensityAlpha = FALSE;
	//}}AFX_DATA_INIT
    m_lpDataHandler     = NULL;
    m_lpDataEdit        = NULL;
    m_boCollSphereShow  = false;
    m_boShowVertices    = false;
    m_boShowStaticBB1   = false;
    m_boShowStaticBB2   = false;
}


void CToolboxMesh::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CToolboxMesh)
	DDX_Control(pDX, IDC_MESH_INTENSITYSLIDER, m_IntensitySlider);
	DDX_Text(pDX, IDC_COLLSPHERERADIUS, m_lCollSphereRadius);
	DDX_Text(pDX, IDC_NUMQUADS, m_cstrNumQuads);
	DDX_Text(pDX, IDC_NUMTRIS, m_cstrNumTris);
	DDX_Text(pDX, IDC_NUMVERT, m_cstrNumVert);
	DDX_Text(pDX, IDC_BB1X, m_lBB1x);
	DDX_Text(pDX, IDC_BB1Y, m_lBB1y);
	DDX_Text(pDX, IDC_BB1Z, m_lBB1z);
	DDX_Text(pDX, IDC_BB2X, m_lBB2x);
	DDX_Text(pDX, IDC_BB2Y, m_lBB2y);
	DDX_Text(pDX, IDC_BB2Z, m_lBB2z);
	DDX_Text(pDX, IDC_MESHEXTENTS, m_cstrExtents);
	DDX_Check(pDX, IDC_MESHBB1ON, m_boBB1On);
	DDX_Check(pDX, IDC_MESHBB2ON, m_boBB2On);
	DDX_Check(pDX, IDC_MESHFLAG_COLLIDE, m_boFlagCollide);
	DDX_Check(pDX, IDC_MESHFLAG_VISIBLE, m_boFlagVisible);
	DDX_Text(pDX, IDC_MESH_OBJID, m_cstrObjId);
	DDX_Check(pDX, IDC_MESH_DUMMY, m_boDummyMesh);
	DDX_Check(pDX, IDC_MESH_INTENSITYALPHA, m_boIntensityAlpha);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CToolboxMesh, CDialog)
	//{{AFX_MSG_MAP(CToolboxMesh)
	ON_WM_CLOSE()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_COLLSPHERESHOW, OnCollSphereShow)
	ON_EN_KILLFOCUS(IDC_COLLSPHERERADIUS, OnKillfocusCollsphereradius)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINSPHRADIUS, OnDeltaposSpinsphradius)
	ON_BN_CLICKED(IDC_VERTICESSHOW, OnVerticesshow)
	ON_BN_CLICKED(IDC_MESHLIGHTING, OnMeshlighting)
	ON_EN_KILLFOCUS(IDC_BB1X, OnKillfocusBb1x)
	ON_EN_KILLFOCUS(IDC_BB1Y, OnKillfocusBb1y)
	ON_EN_KILLFOCUS(IDC_BB1Z, OnKillfocusBb1z)
	ON_EN_KILLFOCUS(IDC_BB2X, OnKillfocusBb2x)
	ON_EN_KILLFOCUS(IDC_BB2Y, OnKillfocusBb2y)
	ON_EN_KILLFOCUS(IDC_BB2Z, OnKillfocusBb2z)
	ON_BN_CLICKED(IDC_MESHBB1ON, OnMeshbb1on)
	ON_BN_CLICKED(IDC_MESHBB1SHOW, OnMeshbb1show)
	ON_BN_CLICKED(IDC_MESHBB2ON, OnMeshbb2on)
	ON_BN_CLICKED(IDC_MESHBB2SHOW, OnMeshbb2show)
	ON_BN_CLICKED(IDC_MESHFLAG_COLLIDE, OnMeshflagCollide)
	ON_BN_CLICKED(IDC_MESHFLAG_VISIBLE, OnMeshflagVisible)
	ON_EN_KILLFOCUS(IDC_MESH_OBJID, OnKillfocusMeshObjid)
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_MESH_DUMMY, OnMeshDummy)
	ON_BN_CLICKED(IDC_MESH_INTENSITYALPHA, OnMeshIntensityAlpha)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolboxMesh message handlers

void CToolboxMesh::OnClose() 
{
    vOnClose();
}


void CToolboxMesh::vSetDataTypeHandler(CHandleMesh* lpHandler,CEditMesh* lpEdit)
{
    m_lpDataHandler = lpHandler;
    m_lpDataEdit    = lpEdit;

    DWORD dwNumMesh;

    CTrLstMsh*  lpMsh = lpHandler ? m_lpDataHandler->GetMesh(dwNumMesh) : NULL;
    CTrStatMsh* lpStatMsh = lpHandler ? (m_lpDataHandler->boIsStaticMesh() ? static_cast<CTrStatMsh*>(lpMsh) : NULL) : NULL;
    TR123_MESH* lpMesh = lpMsh ? const_cast<TR123_MESH*>(lpMsh->lpGetMesh(dwNumMesh)) : NULL;

    ((CButton*)GetDlgItem(IDC_COLLSPHERESHOW))->SetWindowText(m_boCollSphereShow ? _T("Hide") : _T("Show"));
    ((CButton*)GetDlgItem(IDC_VERTICESSHOW))->SetWindowText(m_boShowVertices ? _T("Hide") : _T("Show"));
    GetDlgItem(IDC_MESHNAME)->SetWindowText(lpHandler ? lpHandler->lpszGetTitle() : _T(""));
    m_lCollSphereRadius = lpMesh ? lpMesh->lCollisionSize : 0;
    m_IntensitySlider.SetRange(1,100);

    CString s(_T(""));

    if(lpMesh)
        {
        s.Format(_T("%ld"),lpMesh->sNumColoredRectangles + lpMesh->sNumTexturedRectangles);
        m_cstrNumQuads = s;
        s.Format(_T("%ld"),lpMesh->sNumColoredTriangles + lpMesh->sNumTexturedTriangles);
        m_cstrNumTris = s;
        s.Format(_T("%ld"),lpMesh->sNumVertices);
        m_cstrNumVert = s;
        s.Format(_T("%ld,%ld,%ld"), (long)(lpMesh->fMaxX - lpMesh->fMinX),
                                    (long)(lpMesh->fMaxY - lpMesh->fMinY),
                                    (long)(lpMesh->fMaxZ - lpMesh->fMinZ));
        m_boDummyMesh       = lpMesh->boIsDummy ? TRUE : FALSE;
        m_boIntensityAlpha  = lpMesh->boIntensityAlpha ? TRUE : FALSE;
        m_cstrExtents = s;

        if(lpMesh->Lighting.LightingType == MESH_LIGHTING_EXTERNAL)
            {
            ((CWnd*)GetDlgItem(IDC_MESHLIGHTING))->SetWindowText(_T("external"));
            m_IntensitySlider.EnableWindow(false);
            m_IntensitySlider.SetPos(0);
            }
        else
            {
            ((CWnd*)GetDlgItem(IDC_MESHLIGHTING))->SetWindowText(_T("internal"));
            float fIntens = CTRFile::fCalcMeshAvgIntensity(lpMesh, true);
            m_IntensitySlider.EnableWindow(true);
            m_IntensitySlider.SetPos((DWORD) (fIntens * 100));
            }
        }
    else
        {
        m_cstrNumQuads      = _T("");
        m_cstrNumTris       = _T("");
        m_cstrNumVert       = _T("");
        m_cstrExtents       = _T("");
        m_boDummyMesh       = FALSE;
        m_boIntensityAlpha  = FALSE;
        }
    
    if(lpStatMsh)
        {
        WORD wFlags = lpStatMsh->wGetFlags();

        if(wFlags & TRSTATMSH_FLAGS_NONCOLLISIONABLE)   m_boFlagCollide = TRUE; else m_boFlagCollide = FALSE;
        if(wFlags & TRSTATMSH_FLAGS_VISIBLE)            m_boFlagVisible = TRUE; else m_boFlagVisible = FALSE;

        const CVect3D& vecBB1a = lpStatMsh->GetBBVisibility().GetBBLo();
        const CVect3D& vecBB1b = lpStatMsh->GetBBVisibility().GetBBHi();
        const CVect3D& vecBB2a = lpStatMsh->GetBBCollision().GetBBLo();
        const CVect3D& vecBB2b = lpStatMsh->GetBBCollision().GetBBHi();

        m_lBB1x = (long) (vecBB1b[0] - vecBB1a[0]);
        m_lBB1y = (long) (vecBB1b[1] - vecBB1a[1]);
        m_lBB1z = (long) (vecBB1b[2] - vecBB1a[2]);
        m_lBB2x = (long) (vecBB2b[0] - vecBB2a[0]);
        m_lBB2y = (long) (vecBB2b[1] - vecBB2a[1]);
        m_lBB2z = (long) (vecBB2b[2] - vecBB2a[2]);

        ((CButton*)GetDlgItem(IDC_MESHBB1SHOW))->SetWindowText(m_boShowStaticBB1 ? _T("Hide") : _T("Show"));
        ((CButton*)GetDlgItem(IDC_MESHBB2SHOW))->SetWindowText(m_boShowStaticBB2 ? _T("Hide") : _T("Show"));
        ((CButton*)GetDlgItem(IDC_MESHBB1ON))->SetCheck(m_boBB1On ? 1 : 0);
        ((CButton*)GetDlgItem(IDC_MESHBB2ON))->SetCheck(m_boBB2On ? 1 : 0);

        s.Format(_T("%ld"),lpStatMsh->dwGetObjectId());
        m_cstrObjId = s;

        GetDlgItem(IDC_COLLSPHERESHOW)->EnableWindow(false);
        GetDlgItem(IDC_COLLSPHERERADIUS)->EnableWindow(false);
        GetDlgItem(IDC_SPINSPHRADIUS)->EnableWindow(false);

        GetDlgItem(IDC_MESH_OBJID)->EnableWindow(true);
        GetDlgItem(IDC_MESHFLAG_COLLIDE)->EnableWindow(true);
        GetDlgItem(IDC_MESHFLAG_VISIBLE)->EnableWindow(true);
        GetDlgItem(IDC_BB1X)->EnableWindow(true);
        GetDlgItem(IDC_BB1Y)->EnableWindow(true);
        GetDlgItem(IDC_BB1Z)->EnableWindow(true);
        GetDlgItem(IDC_MESHBB1SHOW)->EnableWindow(true);
        GetDlgItem(IDC_MESHBB1ON)->EnableWindow(true);
        GetDlgItem(IDC_BB2X)->EnableWindow(true);
        GetDlgItem(IDC_BB2Y)->EnableWindow(true);
        GetDlgItem(IDC_BB2Z)->EnableWindow(true);
        GetDlgItem(IDC_MESHBB2SHOW)->EnableWindow(true);
        GetDlgItem(IDC_MESHBB2ON)->EnableWindow(true);
        }
    else
        {
        m_boFlagCollide = FALSE;
        m_boFlagVisible = FALSE;
        m_lBB1x = m_lBB1y = m_lBB1z = m_lBB2x = m_lBB2y = m_lBB2z = 0;
        ((CButton*)GetDlgItem(IDC_MESHBB1SHOW))->SetWindowText(_T("Show"));
        ((CButton*)GetDlgItem(IDC_MESHBB2SHOW))->SetWindowText(_T("Show"));
        ((CButton*)GetDlgItem(IDC_MESHBB1ON))->SetCheck(0);
        ((CButton*)GetDlgItem(IDC_MESHBB2ON))->SetCheck(0);
        m_cstrObjId = _T("");

        GetDlgItem(IDC_COLLSPHERESHOW)->EnableWindow(true);
        GetDlgItem(IDC_COLLSPHERERADIUS)->EnableWindow(true);
        GetDlgItem(IDC_SPINSPHRADIUS)->EnableWindow(true);

        GetDlgItem(IDC_MESH_OBJID)->EnableWindow(false);
        GetDlgItem(IDC_MESHFLAG_COLLIDE)->EnableWindow(false);
        GetDlgItem(IDC_MESHFLAG_VISIBLE)->EnableWindow(false);
        GetDlgItem(IDC_BB1X)->EnableWindow(false);
        GetDlgItem(IDC_BB1Y)->EnableWindow(false);
        GetDlgItem(IDC_BB1Z)->EnableWindow(false);
        GetDlgItem(IDC_MESHBB1SHOW)->EnableWindow(false);
        GetDlgItem(IDC_MESHBB1ON)->EnableWindow(false);
        GetDlgItem(IDC_BB2X)->EnableWindow(false);
        GetDlgItem(IDC_BB2Y)->EnableWindow(false);
        GetDlgItem(IDC_BB2Z)->EnableWindow(false);
        GetDlgItem(IDC_MESHBB2SHOW)->EnableWindow(false);
        GetDlgItem(IDC_MESHBB2ON)->EnableWindow(false);
        }

    UpdateData(FALSE);
}


void CToolboxMesh::OnMeshlighting() 
{
    if(!m_lpDataHandler  ||  !m_lpDataEdit) return;

	CButton* lpButton = (CButton*)GetDlgItem(IDC_MESHLIGHTING);

    CString cstrTxt;
    enumMeshLighting Lighting;
    
    lpButton->GetWindowText(cstrTxt);

    bool    boRecalcIntens = false;
    DWORD   dwNumMesh;

    CTrLstMsh*  lpMsh = m_lpDataHandler->GetMesh(dwNumMesh);
    TR123_MESH* lpMesh = const_cast<TR123_MESH*>(lpMsh->lpGetMesh(dwNumMesh));

    if(cstrTxt == _T("internal"))
        {
        lpButton->SetWindowText(_T("external"));
        Lighting = MESH_LIGHTING_EXTERNAL;
        m_IntensitySlider.EnableWindow(false);
        m_IntensitySlider.SetPos(0);
        }
    else
        {
        lpButton->SetWindowText(_T("internal"));
        Lighting = MESH_LIGHTING_INTERNAL;
        m_IntensitySlider.EnableWindow(true);
        boRecalcIntens = true;
        }

    CTRFile::vChangeMeshLightingType(lpMesh,Lighting,true);

    if(boRecalcIntens)
        {
        float fIntens = CTRFile::fCalcMeshAvgIntensity(lpMesh, true);
        m_IntensitySlider.SetPos((DWORD) (fIntens * 100));
        }

    m_lpDataHandler->vSetChanged();
}


void CToolboxMesh::OnCollSphereShow() 
{
	CButton* lpButton = (CButton*)GetDlgItem(IDC_COLLSPHERESHOW);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("Show"))
        {
        lpButton->SetWindowText(_T("Hide"));
        m_boCollSphereShow = true;
        }
    else
        {
        lpButton->SetWindowText(_T("Show"));
        m_boCollSphereShow = false;
        }

    if(m_lpDataEdit) m_lpDataEdit->vSetShowCollSphere(m_boCollSphereShow);
}


void CToolboxMesh::OnKillfocusCollsphereradius() 
{
    UpdateData(TRUE);

    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD dwNumMesh;
        CTrLstMsh*  lpMsh = m_lpDataHandler->GetMesh(dwNumMesh);
        TR123_MESH* lpMesh = const_cast<TR123_MESH*>(lpMsh->lpGetMesh(dwNumMesh));

        lpMesh->lCollisionSize = m_lCollSphereRadius;
        m_lpDataEdit->vRedrawOpenGLWnd();

        m_lpDataHandler->vSetChanged();
        }
}


void CToolboxMesh::OnDeltaposSpinsphradius(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	
    UpdateData(TRUE);

    m_lCollSphereRadius -= pNMUpDown->iDelta;

    UpdateData(FALSE);

    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD dwNumMesh;
        CTrLstMsh*  lpMsh = m_lpDataHandler->GetMesh(dwNumMesh);
        TR123_MESH* lpMesh = const_cast<TR123_MESH*>(lpMsh->lpGetMesh(dwNumMesh));

        lpMesh->lCollisionSize = m_lCollSphereRadius;
        m_lpDataEdit->vRedrawOpenGLWnd();

        m_lpDataHandler->vSetChanged();
        }

	*pResult = 0;
}


void CToolboxMesh::OnVerticesshow() 
{
	CButton* lpButton = (CButton*)GetDlgItem(IDC_VERTICESSHOW);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("Show"))
        {
        lpButton->SetWindowText(_T("Hide"));
        m_boShowVertices = true;
        }
    else
        {
        lpButton->SetWindowText(_T("Show"));
        m_boShowVertices = false;
        }

    if(m_lpDataEdit) m_lpDataEdit->vSetShowVertices(m_boShowVertices);
}

void CToolboxMesh::OnKillfocusBb1x() 
{
    UpdateData(TRUE);

    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD dwNumMesh;
        CTrStatMsh* lpStatMsh = m_lpDataHandler->boIsStaticMesh() ? static_cast<CTrStatMsh*>(m_lpDataHandler->GetMesh(dwNumMesh)) : NULL;

        if(lpStatMsh)
            {
            CBoundingBox& BB = lpStatMsh->GetBBVisibility();
            const CVect3D& vecMin = BB.GetBBLo();
            const CVect3D& vecMax = BB.GetBBHi();

            long lMid = (vecMin[0] + vecMax[0]) / 2;

            BB.vSetBBLo(CVect3D(lMid - m_lBB1x / 2,vecMin[1],vecMin[2]));
            BB.vSetBBHi(CVect3D(lMid + m_lBB1x / 2,vecMax[1],vecMax[2]));

            m_lpDataEdit->vRedrawOpenGLWnd();
            m_lpDataHandler->vSetChanged();
            }
        }
}

void CToolboxMesh::OnKillfocusBb1y() 
{
    UpdateData(TRUE);

    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD dwNumMesh;
        CTrStatMsh* lpStatMsh = m_lpDataHandler->boIsStaticMesh() ? static_cast<CTrStatMsh*>(m_lpDataHandler->GetMesh(dwNumMesh)) : NULL;

        if(lpStatMsh)
            {
            CBoundingBox& BB = lpStatMsh->GetBBVisibility();
            const CVect3D& vecMin = BB.GetBBLo();
            const CVect3D& vecMax = BB.GetBBHi();

            long lMid = (vecMin[1] + vecMax[1]) / 2;

            BB.vSetBBLo(CVect3D(vecMin[0],lMid - m_lBB1y / 2,vecMin[2]));
            BB.vSetBBHi(CVect3D(vecMax[0],lMid + m_lBB1y / 2,vecMax[2]));

            m_lpDataEdit->vRedrawOpenGLWnd();
            m_lpDataHandler->vSetChanged();
            }
        }
}

void CToolboxMesh::OnKillfocusBb1z() 
{
    UpdateData(TRUE);

    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD dwNumMesh;
        CTrStatMsh* lpStatMsh = m_lpDataHandler->boIsStaticMesh() ? static_cast<CTrStatMsh*>(m_lpDataHandler->GetMesh(dwNumMesh)) : NULL;

        if(lpStatMsh)
            {
            CBoundingBox& BB = lpStatMsh->GetBBVisibility();
            const CVect3D& vecMin = BB.GetBBLo();
            const CVect3D& vecMax = BB.GetBBHi();

            long lMid = (vecMin[2] + vecMax[2]) / 2;

            BB.vSetBBLo(CVect3D(vecMin[0],vecMin[1],lMid - m_lBB1z / 2));
            BB.vSetBBHi(CVect3D(vecMax[0],vecMax[1],lMid + m_lBB1z / 2));

            m_lpDataEdit->vRedrawOpenGLWnd();
            m_lpDataHandler->vSetChanged();
            }
        }
}

void CToolboxMesh::OnKillfocusBb2x() 
{
    UpdateData(TRUE);

    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD dwNumMesh;
        CTrStatMsh* lpStatMsh = m_lpDataHandler->boIsStaticMesh() ? static_cast<CTrStatMsh*>(m_lpDataHandler->GetMesh(dwNumMesh)) : NULL;

        if(lpStatMsh)
            {
            CBoundingBox& BB = lpStatMsh->GetBBCollision();
            const CVect3D& vecMin = BB.GetBBLo();
            const CVect3D& vecMax = BB.GetBBHi();

            long lMid = (vecMin[0] + vecMax[0]) / 2;

            BB.vSetBBLo(CVect3D(lMid - m_lBB1x / 2,vecMin[1],vecMin[2]));
            BB.vSetBBHi(CVect3D(lMid + m_lBB1x / 2,vecMax[1],vecMax[2]));

            m_lpDataEdit->vRedrawOpenGLWnd();
            m_lpDataHandler->vSetChanged();
            }
        }
}

void CToolboxMesh::OnKillfocusBb2y() 
{
    UpdateData(TRUE);

    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD dwNumMesh;
        CTrStatMsh* lpStatMsh = m_lpDataHandler->boIsStaticMesh() ? static_cast<CTrStatMsh*>(m_lpDataHandler->GetMesh(dwNumMesh)) : NULL;

        if(lpStatMsh)
            {
            CBoundingBox& BB = lpStatMsh->GetBBCollision();
            const CVect3D& vecMin = BB.GetBBLo();
            const CVect3D& vecMax = BB.GetBBHi();

            long lMid = (vecMin[1] + vecMax[1]) / 2;

            BB.vSetBBLo(CVect3D(vecMin[0],lMid - m_lBB1y / 2,vecMin[2]));
            BB.vSetBBHi(CVect3D(vecMax[0],lMid + m_lBB1y / 2,vecMax[2]));

            m_lpDataEdit->vRedrawOpenGLWnd();
            m_lpDataHandler->vSetChanged();
            }
        }
}

void CToolboxMesh::OnKillfocusBb2z() 
{
    UpdateData(TRUE);

    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD dwNumMesh;
        CTrStatMsh* lpStatMsh = m_lpDataHandler->boIsStaticMesh() ? static_cast<CTrStatMsh*>(m_lpDataHandler->GetMesh(dwNumMesh)) : NULL;

        if(lpStatMsh)
            {
            CBoundingBox& BB = lpStatMsh->GetBBCollision();
            const CVect3D& vecMin = BB.GetBBLo();
            const CVect3D& vecMax = BB.GetBBHi();

            long lMid = (vecMin[2] + vecMax[2]) / 2;

            BB.vSetBBLo(CVect3D(vecMin[0],vecMin[1],lMid - m_lBB1z / 2));
            BB.vSetBBHi(CVect3D(vecMax[0],vecMax[1],lMid + m_lBB1z / 2));

            m_lpDataEdit->vRedrawOpenGLWnd();
            m_lpDataHandler->vSetChanged();
            }
        }
}

void CToolboxMesh::OnMeshbb1on() 
{
	UpdateData(TRUE);
	
    if(m_lpDataEdit) m_lpDataEdit->vSetStaticBB1IsSel(m_boBB1On ? TRUE : FALSE);
}

void CToolboxMesh::OnMeshbb1show() 
{
	CButton* lpButton = (CButton*)GetDlgItem(IDC_MESHBB1SHOW);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("Show"))
        {
        lpButton->SetWindowText(_T("Hide"));
        m_boShowStaticBB1 = true;
        }
    else
        {
        lpButton->SetWindowText(_T("Show"));
        m_boShowStaticBB1 = false;
        }

    if(m_lpDataEdit) m_lpDataEdit->vSetShowStaticBB1(m_boShowStaticBB1);
}

void CToolboxMesh::OnMeshbb2on() 
{
	UpdateData(TRUE);

    if(m_lpDataEdit) m_lpDataEdit->vSetStaticBB2IsSel(m_boBB2On ? TRUE : FALSE);
}

void CToolboxMesh::OnMeshbb2show() 
{
	CButton* lpButton = (CButton*)GetDlgItem(IDC_MESHBB2SHOW);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("Show"))
        {
        lpButton->SetWindowText(_T("Hide"));
        m_boShowStaticBB2 = true;
        }
    else
        {
        lpButton->SetWindowText(_T("Show"));
        m_boShowStaticBB2 = false;
        }

    if(m_lpDataEdit) m_lpDataEdit->vSetShowStaticBB2(m_boShowStaticBB2);
}

void CToolboxMesh::OnMeshflagCollide() 
{
	UpdateData(TRUE);
	
    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD dwNumMesh;
        CTrStatMsh* lpStatMsh = m_lpDataHandler->boIsStaticMesh() ? static_cast<CTrStatMsh*>(m_lpDataHandler->GetMesh(dwNumMesh)) : NULL;

        if(lpStatMsh)
            {
            WORD wFlags = lpStatMsh->wGetFlags();

            if(m_boFlagCollide) wFlags |= TRSTATMSH_FLAGS_NONCOLLISIONABLE; else wFlags &= ~TRSTATMSH_FLAGS_NONCOLLISIONABLE;

            lpStatMsh->vSetFlags(wFlags);
            m_lpDataHandler->vSetChanged();
            }
        }
}

void CToolboxMesh::OnMeshflagVisible() 
{
	UpdateData(TRUE);
	
    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD dwNumMesh;
        CTrStatMsh* lpStatMsh = m_lpDataHandler->boIsStaticMesh() ? static_cast<CTrStatMsh*>(m_lpDataHandler->GetMesh(dwNumMesh)) : NULL;

        if(lpStatMsh)
            {
            WORD wFlags = lpStatMsh->wGetFlags();

            if(m_boFlagVisible) wFlags |= TRSTATMSH_FLAGS_VISIBLE; else wFlags &= ~TRSTATMSH_FLAGS_VISIBLE;

            lpStatMsh->vSetFlags(wFlags);
            m_lpDataHandler->vSetChanged();
            }
        }
}

void CToolboxMesh::OnKillfocusMeshObjid() 
{
    DWORD dwNumMesh;
    CTrStatMsh* lpStatMsh = m_lpDataHandler->boIsStaticMesh() ? static_cast<CTrStatMsh*>(m_lpDataHandler->GetMesh(dwNumMesh)) : NULL;

    if(!lpStatMsh) return;

	UpdateData(TRUE);

    lpStatMsh->vSetObjectId(_ttol(m_cstrObjId));
    if(m_lpDataHandler) m_lpDataHandler->vSetChanged();
}


void CToolboxMesh::OnMeshDummy() 
{
	UpdateData(TRUE);

    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD       dwNumMesh;
        CTrLstMsh*  lpMsh = m_lpDataHandler->GetMesh(dwNumMesh);
        TR123_MESH* lpMesh = const_cast<TR123_MESH*>(lpMsh->lpGetMesh(dwNumMesh));

        lpMesh->boIsDummy = m_boDummyMesh ? true : false;

        m_lpDataEdit->vRedrawOpenGLWnd();
        m_lpDataHandler->vSetChanged();
        }
}


void CToolboxMesh::OnMeshIntensityAlpha() 
{
	UpdateData(TRUE);

    if(m_lpDataHandler  &&  m_lpDataEdit)
        {
        DWORD       dwNumMesh;
        CTrLstMsh*  lpMsh = m_lpDataHandler->GetMesh(dwNumMesh);
        TR123_MESH* lpMesh = const_cast<TR123_MESH*>(lpMsh->lpGetMesh(dwNumMesh));

        lpMesh->boIntensityAlpha = m_boIntensityAlpha ? true : false;

        CTRFile::vSetMeshIntensityAlpha(lpMesh,const_cast<TR2_OBJECT_TEXTURE*>(lpMsh->lpGetFragText()),lpMesh->boIntensityAlpha);

        m_lpDataEdit->vRedrawOpenGLWnd();
        m_lpDataHandler->vSetChanged();
        }
}


void CToolboxMesh::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    CString s;

    int iCtrlId = pScrollBar->GetDlgCtrlID();

    switch(nSBCode)
        {
        case TB_THUMBPOSITION:
        case TB_PAGEDOWN:
        case TB_PAGEUP:
        case TB_THUMBTRACK:
            {
            CSliderCtrl* lpSlider = reinterpret_cast<CSliderCtrl*>(pScrollBar);

            int nPos = lpSlider->GetPos();

            switch(iCtrlId)
                {
                case IDC_MESH_INTENSITYSLIDER:
                    {
                    if(m_lpDataHandler  &&  m_lpDataEdit)
                        {
                        DWORD       dwNumMesh;
                        CTrLstMsh*  lpMsh = m_lpDataHandler->GetMesh(dwNumMesh);
                        TR123_MESH* lpMesh = const_cast<TR123_MESH*>(lpMsh->lpGetMesh(dwNumMesh));

                        float fIntensity = nPos / 100.0f;

                        CTRFile::vSetMeshIntensity(lpMesh, fIntensity, TRUE);

                        m_lpDataEdit->vRedrawOpenGLWnd();
                        m_lpDataHandler->vSetChanged();
                        }
                    break;
                    }
                }
            break;
            }
        }

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
