// ToolboxSprite.cpp : implementation file
//

#include "stdafx.h"
#include "trviewer.h"
#include "EditSprite.h"
#include "HandleSprite.h"
#include "ToolboxSprite.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CToolboxSprite dialog


CToolboxSprite::CToolboxSprite(CWnd* pParent /*=NULL*/)
{
    CDialog(CToolboxSprite::IDD, pParent);

	//{{AFX_DATA_INIT(CToolboxSprite)
    m_dwAnimSpeed       = 20;
	m_cstrSprSeqName = _T("");
	m_boShowBorder = FALSE;
	m_fListWidth = 256.0f;
	m_cstrObjId = _T("");
	//}}AFX_DATA_INIT
    m_lpDataHandler     = NULL;
    m_lpDataEdit        = NULL;
    m_boTypeAnimated    = true;
}


void CToolboxSprite::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CToolboxSprite)
	DDX_Control(pDX, IDC_SPR_SPEED, m_SliderSpeed);
	DDX_Text(pDX, IDC_SPR_SPEEDVALUE, m_dwAnimSpeed);
	DDX_Text(pDX, IDC_SPR_NAME, m_cstrSprSeqName);
	DDX_Check(pDX, IDC_SPR_SHOWBORDER, m_boShowBorder);
	DDX_Text(pDX, IDC_SPR_LISTWIDTH, m_fListWidth);
	DDV_MinMaxFloat(pDX, m_fListWidth, 0.f, 1.e+006f);
	DDX_Text(pDX, IDC_SPRITE_OBJID, m_cstrObjId);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CToolboxSprite, CDialog)
	//{{AFX_MSG_MAP(CToolboxSprite)
	ON_WM_CLOSE()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_SPR_SHOWBORDER, OnSprShowborder)
	ON_BN_CLICKED(IDC_SPR_TYPEANIM, OnSprTypeanim)
	ON_BN_CLICKED(IDC_SPR_TYPELIST, OnSprTypelist)
	ON_EN_KILLFOCUS(IDC_SPR_LISTWIDTH, OnKillfocusSprListwidth)
	ON_EN_KILLFOCUS(IDC_SPRITE_OBJID, OnKillfocusSpriteObjid)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolboxSprite message handlers

void CToolboxSprite::OnClose() 
{
    vOnClose();
}


void CToolboxSprite::vSetDataTypeHandler(CHandleSprite* lpHandler,CEditSprite* lpEdit)
{
    bool    boNewSprite = true;
    CTrLstSpr* lpSprSeq = lpHandler ? lpHandler->GetSpr() : NULL;

    if(m_lpDataHandler)
        {
        CTrLstSpr*   lpOldSprite = m_lpDataHandler->GetSpr();
        boNewSprite = (lpSprSeq != lpOldSprite);
        }

    m_lpDataHandler = lpHandler;
    m_lpDataEdit    = lpEdit;

    m_SliderSpeed.SetRange(0,100);

    m_cstrSprSeqName = lpHandler ? lpHandler->lpszGetTitle() : _T("");

    if(m_boTypeAnimated)
        {
        ((CButton*)GetDlgItem(IDC_SPR_TYPEANIM))->SetCheck(1);
        ((CButton*)GetDlgItem(IDC_SPR_TYPELIST))->SetCheck(0);
        }
    else
        {
        ((CButton*)GetDlgItem(IDC_SPR_TYPEANIM))->SetCheck(0);
        ((CButton*)GetDlgItem(IDC_SPR_TYPELIST))->SetCheck(1);
        }

    if(lpSprSeq)
        {
        CString s;

        s.Format(_T(" (%ld sprites)"),lpSprSeq->dwGetNumSprites());
        m_cstrSprSeqName += s;

        s.Format(_T("%ld"),lpSprSeq->dwGetObjectId());
        m_cstrObjId = s;
        }

    if(m_lpDataEdit)
        {
        }

    if(boNewSprite)
        {
        m_dwAnimSpeed = 20;
        m_SliderSpeed.SetPos(m_dwAnimSpeed);

        if(m_lpDataEdit)
            {
            m_lpDataEdit->vSetSprSeqShowBorder(m_boShowBorder ? true : false);
            m_lpDataEdit->vSetSprSeqOverallSpeed(m_dwAnimSpeed);
            m_lpDataEdit->vSetSprSeqTypeAnimated(m_boTypeAnimated);
            m_lpDataEdit->vSetSprSeqListWidth(m_fListWidth);
            }
        }

    UpdateData(FALSE);
}


void CToolboxSprite::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    CString s;

    int iCtrlId = pScrollBar->GetDlgCtrlID();

    switch(nSBCode)
        {
        case TB_THUMBPOSITION:
        case TB_PAGEDOWN:
        case TB_PAGEUP:
        case TB_THUMBTRACK:
            {
            CSliderCtrl* lpSlider = reinterpret_cast<CSliderCtrl*>(pScrollBar);
            int nPos = lpSlider->GetPos();
            switch(iCtrlId)
                {
                case IDC_SPR_SPEED:
                    {
                    m_dwAnimSpeed = nPos;
                    m_lpDataEdit->vSetSprSeqOverallSpeed(m_dwAnimSpeed);
                    s.Format(_T("%ld"),m_dwAnimSpeed);
                    CWnd* lpWnd = GetDlgItem(IDC_SPR_SPEEDVALUE);
                    lpWnd->SetWindowText(s);
                    break;
                    }
                }
            break;
            }
        }

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CToolboxSprite::OnSprShowborder() 
{
	UpdateData(TRUE);
	
    if(m_lpDataEdit)
        {
        m_lpDataEdit->vSetSprSeqShowBorder(m_boShowBorder ? true : false);
        }
}

void CToolboxSprite::OnSprTypeanim() 
{
    UpdateData(TRUE);	

    m_boTypeAnimated = ((CButton*)GetDlgItem(IDC_SPR_TYPEANIM))->GetCheck() == 1;

    if(m_lpDataEdit)
        {
        m_lpDataEdit->vSetSprSeqTypeAnimated(m_boTypeAnimated);
        }
}

void CToolboxSprite::OnSprTypelist() 
{
    UpdateData(TRUE);	
	
    m_boTypeAnimated = ((CButton*)GetDlgItem(IDC_SPR_TYPEANIM))->GetCheck() == 1;

    if(m_lpDataEdit)
        {
        m_lpDataEdit->vSetSprSeqTypeAnimated(m_boTypeAnimated);
        }
}

void CToolboxSprite::OnKillfocusSprListwidth() 
{
    UpdateData(TRUE);
    
    if(m_lpDataEdit)
        {
        m_lpDataEdit->vSetSprSeqListWidth(m_fListWidth);
        }
}

void CToolboxSprite::OnKillfocusSpriteObjid() 
{
    CTrLstSpr* lpSprSeq = m_lpDataHandler ? m_lpDataHandler->GetSpr() : NULL;

    if(!lpSprSeq) return;
	
    UpdateData(TRUE);

    lpSprSeq->vSetObjectId(_ttol(m_cstrObjId));
}
